#ifndef D3DBASE_H
#define D3DBASE_H

#include "window.h"

#include <windows.h>
#include <d3d8.h>

//#define D3DB_XRES 800
//#define D3DB_YRES 600

#define RELEASE(x) if(x){(x)->Release();}

// class cd3dbase
//
// direct3d base class
class cd3dbase : public cwindow
{
	LPDIRECT3D8 d3d;
	bool fullscreen;
	D3DPRESENT_PARAMETERS d3dpp;

	virtual onmessage(int msg, int wparam, int lparam);
	virtual onminimax(int WindowStyle);
	virtual onactivate();
	virtual ondeactivate();
	virtual onsize(int dx, int dy);
	initd3d();
	destroyd3d();
protected:
	virtual reinitd3d();
public:
	LPDIRECT3DDEVICE8 d3ddevice;
	int xres, yres, fsxres, fsyres;

	cd3dbase(HINSTANCE Instance, int WindowStyle, char *caption, int dx, int dy);
	~cd3dbase();
};

// d3dbase types, constants, macros

struct D3DBVERTEX
{
	float x, y, z, nx, ny, nz, tu, tv;
};

struct D3DBLVERTEX
{
	float x, y, z;
	D3DCOLOR color;
	float tu, tv;
};

#define D3DBFVF_VERTEX (D3DFVF_XYZ | D3DFVF_NORMAL|D3DFVF_TEX1)
#define D3DBFVF_LVERTEX (D3DFVF_XYZ|D3DFVF_DIFFUSE|D3DFVF_TEX1)
#define D3DBFVF_TLVERTEX (D3DFVF_XYZRHW|D3DFVF_DIFFUSE|D3DFVF_TEX1)

#define RGBA_MAKE(r, g, b, a) ((a<<24)+(r<<16)+(g<<8)+b)

D3DVECTOR makevector(float x, float y, float z);
D3DBVERTEX makevertex(D3DVECTOR w, D3DVECTOR n, float tu, float tv);
D3DBLVERTEX makelvertex(D3DVECTOR w, D3DCOLOR c, float tu, float tv);
D3DMATRIX makematrix(float a, float b, float c, float d, float e, float f, float g, float h, float i, float j, float k, float l, float m, float n, float o, float p);

#endif