#include "mission.h"

#include "gs.h"
#include "t3_d3dbase.h"
#include "tank31fct.h"
#include "terra.h"

#include <stdio.h>

tmission mission;


void savegame(char *fname) {
	FILE *f;
	statusreal(1403);
	hwstatus("saving game...\n");
	f=fopen(fname, "wb");
	if(f){
		unsigned short typ;
		float fl;
		// 1: mission name
		typ = 1;
		fwrite(&typ, 2, 1, f);
		fprintf(f, "%s", mission.name);
		unsigned char b = 0;
		fwrite(&b, 1, 1, f);
		int i;
		// 2: tanks, deprecated
		// 3: orders
		for(i = 0; i < ORDERLINES; i++)
		{
			typ = 3;
			fwrite(&typ, 2, 1, f);
			fprintf(f, "%s", mission.orders[i]);
			b = 0;
			fwrite(&b, 1, 1, f);
		}
		// 4: ways, deprecated
		// 5: orders
		typ = 5;
		fwrite(&typ, 2, 1, f);
		statusreal(1464);
		fl = (float)mission.goal.survive;
		fwrite(&fl, 4, 1, f);
		fl = (float)mission.goal.kill;
		fwrite(&fl, 4, 1, f);
		fl = (float)(mission.goal.killall?1:-1);
		fwrite(&fl, 4, 1, f);
		fl = (float)(mission.goal.location?1:-1);
		fwrite(&fl, 4, 1, f);
		fl = (float)(mission.goal.killlocation?1:-1);
		fwrite(&fl, 4, 1, f);
		fl = (float)(mission.goal.ban?1:-1);
		fwrite(&fl, 4, 1, f);
		mission.goal.gotox/=GEOFAC;
		mission.goal.gotoy/=GEOFAC;
		mission.goal.killx/=GEOFAC;
		mission.goal.killy/=GEOFAC;
		mission.goal.banx/=GEOFAC;
		mission.goal.bany/=GEOFAC;
		fwrite(&mission.goal.gotox, 4, 1, f);
		fwrite(&mission.goal.gotoy, 4, 1, f);
		fwrite(&mission.goal.radius, 4, 1, f);
		fwrite(&mission.goal.killx, 4, 1, f);
		fwrite(&mission.goal.killy, 4, 1, f);
		fwrite(&mission.goal.killradius, 4, 1, f);
		fwrite(&mission.goal.banx, 4, 1, f);
		fwrite(&mission.goal.bany, 4, 1, f);
		fwrite(&mission.goal.banradius, 4, 1, f);
		mission.goal.gotox*=GEOFAC;
		mission.goal.gotoy*=GEOFAC;
		mission.goal.killx*=GEOFAC;
		mission.goal.killy*=GEOFAC;
		mission.goal.banx*=GEOFAC;
		mission.goal.bany*=GEOFAC;
		statusreal(1465);
		// 6: next mission
		typ = 6;
		fwrite(&typ, 2, 1, f);
		fprintf(f, "%s", mission.next);
		b = 0;
		fwrite(&b, 1, 1, f);
		// 7: light
		typ = 7;
		fwrite(&typ, 2, 1, f);
		fwrite(&mission.light[0].x, 4, 1, f);
		fwrite(&mission.light[0].y, 4, 1, f);
		fwrite(&mission.light[0].z, 4, 1, f);
		fwrite(&mission.light[0].r, 4, 1, f);
		fwrite(&mission.light[0].g, 4, 1, f);
		fwrite(&mission.light[0].b, 4, 1, f);
		fwrite(&mission.light[1].x, 4, 1, f);
		fwrite(&mission.light[1].y, 4, 1, f);
		fwrite(&mission.light[1].z, 4, 1, f);
		fwrite(&mission.light[1].r, 4, 1, f);
		fwrite(&mission.light[1].g, 4, 1, f);
		fwrite(&mission.light[1].b, 4, 1, f);
		// 8: milobjs (tanks)
		for(i = 0; i < mission.numomil; i++)
		{
			if(!mission.omildesc[i].thisisstatic)
			{
				typ = 8;
				fwrite(&typ, 2, 1, f);
				statusreal(1466);
				fl = (float)mission.omildesc[i].owner;
				fwrite(&fl, 4, 1, f);
				fl = (float)mission.omildesc[i].typ;
				fwrite(&fl, 4, 1, f);
				fl = mission.omildesc[i].posx/GEOFAC;
				fwrite(&fl, 4, 1, f);
				fl = mission.omildesc[i].posy/GEOFAC;
				fwrite(&fl, 4, 1, f);
				fl = (float)mission.omildesc[i].target;
				fwrite(&fl, 4, 1, f);
				fl = mission.omildesc[i].targetx/GEOFAC;
				fwrite(&fl, 4, 1, f);
				fl = mission.omildesc[i].targety/GEOFAC;
				fwrite(&fl, 4, 1, f);
				fl = (float)(mission.omildesc[i].noorders?1:-1);
				fwrite(&fl, 4, 1, f);
				fl = (float)(mission.omildesc[i].nogoal?1:-1);
				fwrite(&fl, 4, 1, f);
				fl = (float)(mission.omildesc[i].mustsurvive?1:-1);
				fwrite(&fl, 4, 1, f);
				fl = (float)(mission.omildesc[i].mustdie?1:-1);
				fwrite(&fl, 4, 1, f);
				statusreal(1472);
			}
		}
		// 9: start point
		typ = 9;
		fwrite(&typ, 2, 1, f);
		view.px/=GEOFAC;
		view.py/=GEOFAC;
		fwrite(&view.px, 4, 1, f);
		fwrite(&view.py, 4, 1, f);
		view.px*=GEOFAC;
		view.py*=GEOFAC;
		// 10: houses
		for(i = 0; i < mission.numomil; i++)
		{
			if(mission.omildesc[i].thisisstatic)
			{
				typ = 10;
				fwrite(&typ, 2, 1, f);
				statusreal(1466);
				fl = (float)mission.omildesc[i].owner;
				fwrite(&fl, 4, 1, f);
				fl = (float)mission.omildesc[i].typ;
				fwrite(&fl, 4, 1, f);
				fl = mission.omildesc[i].posx/GEOFAC;
				fwrite(&fl, 4, 1, f);
				fl = mission.omildesc[i].posy/GEOFAC;
				fwrite(&fl, 4, 1, f);
				fl = (float)mission.omildesc[i].a;
				fwrite(&fl, 4, 1, f);
				fl = (float)(mission.omildesc[i].noorders?1:-1);
				fwrite(&fl, 4, 1, f);
				fl = (float)(mission.omildesc[i].nogoal?1:-1);
				fwrite(&fl, 4, 1, f);
				fl = (float)(mission.omildesc[i].mustsurvive?1:-1);
				fwrite(&fl, 4, 1, f);
				fl = (float)(mission.omildesc[i].mustdie?1:-1);
				fwrite(&fl, 4, 1, f);
				statusreal(1472);
			}
		}
		// 11: ways
		for(i=0;i<TERRAWAYS;i++){
			if(terra.way[i].used){
				statusreal(1456);
				typ = 11;
				fwrite(&typ, 2, 1, f);
				fl = terra.way[i].x1*TERRAFAC/GEOFAC;
				fwrite(&fl, 4, 1, f);
				fl = terra.way[i].y1*TERRAFAC/GEOFAC;
				fwrite(&fl, 4, 1, f);
				fl = terra.way[i].x2*TERRAFAC/GEOFAC;
				fwrite(&fl, 4, 1, f);
				fl = terra.way[i].y2*TERRAFAC/GEOFAC;
				fwrite(&fl, 4, 1, f);
				fl = (float)terra.way[i].typ;
				fwrite(&fl, 4, 1, f);
				statusreal(1457);
			}
		}
		// 1024: snow
		typ = 1024;
		fwrite(&typ, 2, 1, f);
		fl = (float)(mission.snow?1:-1);
		fwrite(&fl, 4, 1, f);
		// 1025: trees
		for(i = 0; i < TREES; i++)
		{
			typ = 1025;
			fwrite(&typ, 2, 1, f);
			fwrite(&tree[i].x, 4, 1, f);
			fwrite(&tree[i].y, 4, 1, f);
			fwrite(&tree[i].z, 4, 1, f);
			fwrite(&tree[i].a, 4, 1, f);
			fwrite(&tree[i].b, 4, 1, f);
			fl = (float)tree[i].typ;
			fwrite(&fl, 4, 1, f);
			fl = (float)(tree[i].used?1:-1);
			fwrite(&fl, 4, 1, f);
			fl = (float)(tree[i].falling?1:-1);
			fwrite(&fl, 4, 1, f);
		}
		// 1026: omils
		typ = 1026;
		fwrite(&typ, 2, 1, f);
		fwrite(&omil[0], OMILS, sizeof(mil), f);
		// 1027: shots
		for(i = 0; i < NUMSHOTS; i++)
		{
			if(shot[i].used)
			{
				typ = 1027;
				fwrite(&typ, 2, 1, f);
				fwrite(&shot[i], 1, sizeof(tshot), f);
			}
		}
		// 1028: particles
		for(i = 0; i < PARTICLES; i++)
		{
			if(part[i].used)
			{
				typ = 1028;
				fwrite(&typ, 2, 1, f);
				fwrite(&part[i], 1, sizeof(tparticle), f);
			}
		}
		// 1029: game time
		typ = 1029;
		fwrite(&typ, 2, 1, f);
		fwrite(&speedgs.g, 1, sizeof(speedgs.g), f);

		fclose(f);
	}
	hwstatus("game saved.\n");
}

void loadgame(char *fname) {
	int i;
	int treenr = 0, shotnr = 0, partnr = 0;
	  mission.name[0]=0;
	  mission.namelen=0;
	  mission.next[0]=0;
	  mission.nextlen=0;
	  mission.light[0].x=-1;
	  mission.light[0].y=0.8f;
	  mission.light[0].z=0.4f;
	  mission.light[0].r=0;
	  mission.light[0].g=0.25f;
	  mission.light[0].b=0.75f;
	  mission.light[1].x=1;
	  mission.light[1].y=0.8f;
	  mission.light[1].z=0.4f;
	  mission.light[1].r=0.75f;
	  mission.light[1].g=0.5f;
	  mission.light[1].b=0.0f;
	  for(i=0;i<ORDERLINES;i++){
		mission.orders[i][0]=0;
		mission.orderlen[i]=0;
	  }
	  int ordlen=0;
	  int ordlines=0;
	  mission.numomil=0;
	  mission.goal.survive=-1;
	  view.px=144.5*GEOFAC;
	  view.py=144.5*GEOFAC;
	  statusreal(1401);
	  if(mission.omildesc!=NULL){
		free(mission.omildesc);
		mission.omildesc=NULL;
	  }
	  statusreal(1402);
	  FILE *f;
	  unsigned short typ;
	  statusreal(1403);
	  f=fopen(fname, "rb");
	  if(f==NULL){
		hwstatus("Mission file not found:\n");
		hwstatus(mission.fname);
		hwstatus("\n");
		dxerror();
	  }
	  statusreal(1404);
	  fseek(f, 0, SEEK_END);
	  statusreal(1405);
	  int size=ftell(f);
	  fseek(f, 0, SEEK_SET);
	  statusreal(1406);
	  while(/*!feof(f)*/ftell(f)<size){
		statusreal(1407);
		fread(&typ, 2, 1, f);
		statusreal(1408);
		float fl;
		if(typ==1){
		  statusreal(1409);
		  unsigned char c;
		  int len=1;
		  fread(&c, 1, 1, f);
	//      mission.name=(char*)malloc(40);
		  statusreal(1410);
		  mission.name[0]=c;
		  mission.name[1]=0;
		  while(c!=0){
			statusreal(1411);
			fread(&c, 1, 1, f);
			statusreal(1412);
			if(len<=STRINGLEN-2)len++;
	//        realloc(mission.name, len+1);
			mission.name[len-1]=c;
			mission.name[len]=0;
			statusreal(1413);
		  }
		  statusreal(1414);
		  mission.namelen=len-1;
		}
		statusreal(1415);
		if(typ==6){
		  unsigned char c;
		  int len=1;
		  statusreal(1416);
		  fread(&c, 1, 1, f);
		  statusreal(1417);
	//      mission.name=(char*)malloc(40);
		  mission.next[0]=c;
		  mission.next[1]=0;
		  statusreal(1418);
		  while(c!=0){
			statusreal(1419);
			fread(&c, 1, 1, f);
			statusreal(1420);
			if(len<=STRINGLEN-2)len++;
	//        realloc(mission.name, len+1);
			mission.next[len-1]=c;
			mission.next[len]=0;
			statusreal(1421);
		  }
		  statusreal(1422);
		  mission.nextlen=len-1;
		  statusreal(1423);
		}
		statusreal(1424);
		if(typ==3){
		  statusreal(1425);
		  unsigned char c;
		  fread(&c, 1, 1, f);
		  statusreal(1426);
		  ordlen++;
	//      mission.orders[ordlines]=(char*)malloc(40);
	//      else{
	//        realloc(mission.orders[ordlines], ordlen+1);
	//      }
		  mission.orders[ordlines][ordlen-1]=c;
		  mission.orders[ordlines][ordlen]=0;
		  statusreal(1427);
		  while(c!=0){
			statusreal(1428);
			fread(&c, 1, 1, f);
			statusreal(1429);
			if(ordlen<=STRINGLEN-2)ordlen++;
			statusreal(1430);
	//        mission.orders[ordlines]=realloc(mission.orders[ordlines], ordlen+1);
	//        if(mission.orders[ordlines]==NULL)memerror();
			statusreal(1431);
			mission.orders[ordlines][ordlen-1]=c;
			statusreal(1432);
			mission.orders[ordlines][ordlen]=0;
			statusreal(1433);
		  }
		  statusreal(1434);
		  mission.orderlen[ordlines]=ordlen-1;
		  statusreal(1435);
		  ordlines++;
		  ordlen=0;
		  statusreal(1436);
		}
		statusreal(1437);
/*		if(typ==2){
		  statusreal(1438);
		  mission.numomil++;
		  statusreal(1439);
		  if(mission.omildesc==NULL){
			statusreal(1440);
			mission.omildesc=(tomildesc*)malloc(sizeof(tomildesc));
			if(mission.omildesc==NULL)memerror();
			statusreal(1441);
		  } else {
			statusreal(1442);
			mission.omildesc=(tomildesc*)realloc(mission.omildesc, sizeof(tomildesc)*mission.numomil);
			statusreal(1443);
			if(mission.omildesc==NULL){statusreal(711);memerror();}
			statusreal(1444);
		  }
		  statusreal(1445);
		  fread(&fl, 4, 1, f);
		  statusreal(1446);
		  mission.omildesc[mission.numomil-1].owner=(int)fl;
		  statusreal(1447);
		  fread(&fl, 4, 1, f);
		  mission.omildesc[mission.numomil-1].typ=(int)fl;
		  statusreal(1448);
		  fread(&fl, 4, 1, f);
		  mission.omildesc[mission.numomil-1].posx=fl;
		  statusreal(1449);
		  fread(&fl, 4, 1, f);
		  mission.omildesc[mission.numomil-1].posy=fl;
		  statusreal(1450);
		  mission.omildesc[mission.numomil-1].target=-1;
		  mission.omildesc[mission.numomil-1].noorders=false;
		  mission.omildesc[mission.numomil-1].nogoal=false;
		  mission.omildesc[mission.numomil-1].mustsurvive=false;
		  mission.omildesc[mission.numomil-1].mustdie=false;
		  mission.omildesc[mission.numomil-1].thisisstatic=false;
		  mission.omildesc[mission.numomil-1].a=0;
		  statusreal(1451);
		}*/
		statusreal(1452);
		if(typ==4){
		  statusreal(1453);
		  float x1,y1,x2,y2;
		  statusreal(1454);
		  fread(&x1, 4, 1, f);
		  fread(&y1, 4, 1, f);
		  fread(&x2, 4, 1, f);
		  fread(&y2, 4, 1, f);
		  statusreal(1455);
		  for(i=0;i<TERRAWAYS;i++){
			if(!terra.way[i].used){
			  statusreal(1456);
			  terra.way[i].typ=0;
			  terra.way[i].x1=x1*GEOFAC/TERRAFAC;
			  terra.way[i].y1=y1*GEOFAC/TERRAFAC;
			  terra.way[i].x2=x2*GEOFAC/TERRAFAC;
			  terra.way[i].y2=y2*GEOFAC/TERRAFAC;
			  terra.way[i].used=true;
			  statusreal(1457);
			  break;
			}
			statusreal(1458);
		  }
		  statusreal(1459);
		}
		statusreal(1460);
		if(typ==7){
		  statusreal(1461);
		  fread(&mission.light[0].x, 4, 1, f);
		  fread(&mission.light[0].y, 4, 1, f);
		  fread(&mission.light[0].z, 4, 1, f);
		  fread(&mission.light[0].r, 4, 1, f);
		  fread(&mission.light[0].g, 4, 1, f);
		  fread(&mission.light[0].b, 4, 1, f);
		  fread(&mission.light[1].x, 4, 1, f);
		  fread(&mission.light[1].y, 4, 1, f);
		  fread(&mission.light[1].z, 4, 1, f);
		  fread(&mission.light[1].r, 4, 1, f);
		  fread(&mission.light[1].g, 4, 1, f);
		  fread(&mission.light[1].b, 4, 1, f);
		  statusreal(1462);
		}
		statusreal(1463);
		if(typ==5){
		  statusreal(1464);
		  fread(&fl, 4, 1, f);
		  mission.goal.survive=(int)fl;
		  fread(&fl, 4, 1, f);
		  mission.goal.kill=(int)fl;
		  fread(&fl, 4, 1, f);
		  mission.goal.killall=fl==-1?false:true;
		  fread(&fl, 4, 1, f);
		  mission.goal.location=fl==-1?false:true;
		  fread(&fl, 4, 1, f);
		  mission.goal.killlocation=fl==-1?false:true;
		  fread(&fl, 4, 1, f);
		  mission.goal.ban=fl==-1?false:true;
		  fread(&mission.goal.gotox, 4, 1, f);
		  fread(&mission.goal.gotoy, 4, 1, f);
		  fread(&mission.goal.radius, 4, 1, f);
		  fread(&mission.goal.killx, 4, 1, f);
		  fread(&mission.goal.killy, 4, 1, f);
		  fread(&mission.goal.killradius, 4, 1, f);
		  fread(&mission.goal.banx, 4, 1, f);
		  fread(&mission.goal.bany, 4, 1, f);
		  fread(&mission.goal.banradius, 4, 1, f);
		  mission.goal.gotox*=GEOFAC;
		  mission.goal.gotoy*=GEOFAC;
		  mission.goal.killx*=GEOFAC;
		  mission.goal.killy*=GEOFAC;
		  mission.goal.banx*=GEOFAC;
		  mission.goal.bany*=GEOFAC;
		  statusreal(1465);
		}
		if(typ==8){
		  mission.numomil++;
		  statusreal(1466);
		  if(mission.omildesc==NULL){
			statusreal(1467);
			mission.omildesc=(tomildesc*)malloc(sizeof(tomildesc));
			if(mission.omildesc==NULL)memerror();
			statusreal(1468);
		  } else {
			statusreal(1469);
			if(mission.omildesc==NULL)memerror();
			statusreal(1490);
			if((mission.omildesc=(tomildesc*)realloc(mission.omildesc, sizeof(tomildesc)*mission.numomil))==NULL)memerror();
			statusreal(1491);
		  }
		  statusreal(1471);
		  fread(&fl, 4, 1, f);
		  mission.omildesc[mission.numomil-1].owner=(int)fl;
		  fread(&fl, 4, 1, f);
		  mission.omildesc[mission.numomil-1].typ=(int)fl;
		  fread(&fl, 4, 1, f);
		  mission.omildesc[mission.numomil-1].posx=fl*GEOFAC;
		  fread(&fl, 4, 1, f);
		  mission.omildesc[mission.numomil-1].posy=fl*GEOFAC;
		  fread(&fl, 4, 1, f);
		  mission.omildesc[mission.numomil-1].target=(int)fl;
		  fread(&fl, 4, 1, f);
		  mission.omildesc[mission.numomil-1].targetx=fl*GEOFAC;
		  fread(&fl, 4, 1, f);
		  mission.omildesc[mission.numomil-1].targety=fl*GEOFAC;
		  fread(&fl, 4, 1, f);
		  mission.omildesc[mission.numomil-1].noorders=(fl==-1?false:true);
		  fread(&fl, 4, 1, f);
		  mission.omildesc[mission.numomil-1].nogoal=(fl==-1?false:true);
		  fread(&fl, 4, 1, f);
		  mission.omildesc[mission.numomil-1].mustsurvive=(fl==-1?false:true);
		  fread(&fl, 4, 1, f);
		  mission.omildesc[mission.numomil-1].mustdie=(fl==-1?false:true);
		  mission.omildesc[mission.numomil-1].thisisstatic=false;
		  mission.omildesc[mission.numomil-1].a=0;
		  statusreal(1472);
		}
		if(typ==9){
		  fread(&view.px, 4, 1, f);
		  fread(&view.py, 4, 1, f);
		  view.px*=GEOFAC;
		  view.py*=GEOFAC;
		}
		if(typ==10){
		  mission.numomil++;
		  if(mission.omildesc==NULL){
			mission.omildesc=(tomildesc*)malloc(sizeof(tomildesc));
			if(mission.omildesc==NULL)memerror();
		  } else {
			if((mission.omildesc=(tomildesc*)realloc(mission.omildesc, sizeof(tomildesc)*mission.numomil))==NULL)memerror();
		  }
		  float x,y;
		  fread(&fl, 4, 1, f);
		  mission.omildesc[mission.numomil-1].owner=(int)fl;
		  fread(&fl, 4, 1, f);
		  mission.omildesc[mission.numomil-1].typ=(int)fl;
		  fread(&x, 4, 1, f);
		  mission.omildesc[mission.numomil-1].posx=x*GEOFAC;
		  fread(&y, 4, 1, f);
		  mission.omildesc[mission.numomil-1].posy=y*GEOFAC;
		  fread(&fl, 4, 1, f);
		  mission.omildesc[mission.numomil-1].a=fl;
		  mission.omildesc[mission.numomil-1].target=-1;
		  fread(&fl, 4, 1, f);
		  mission.omildesc[mission.numomil-1].noorders=(fl==-1?false:true);
		  fread(&fl, 4, 1, f);
		  mission.omildesc[mission.numomil-1].nogoal=(fl==-1?false:true);
		  fread(&fl, 4, 1, f);
		  mission.omildesc[mission.numomil-1].mustsurvive=(fl==-1?false:true);
		  fread(&fl, 4, 1, f);
		  mission.omildesc[mission.numomil-1].mustdie=(fl==-1?false:true);
		  mission.omildesc[mission.numomil-1].thisisstatic=true;
		  statusreal(1480);
		  for(i=0;i<TERRAPLAINS;i++){
			statusreal(1481);
			if(!terra.plain[i].used){
			  statusreal(1482);
			  terra.plain[i].x=x*GEOFAC/TERRAFAC;
			  statusreal(1483);
			  terra.plain[i].y=y*GEOFAC/TERRAFAC;
			  statusreal(1484);
			  terra.plain[i].dx=6;
			  terra.plain[i].dy=6;
			  terra.plain[i].used=true;
			  statusreal(1485);
			  break;
			}
			statusreal(1486);
		  }
		  statusreal(1487);
		}
		if(typ==11){
		  statusreal(1452);
		  float x1,y1,x2,y2, typ;
		  statusreal(1453);
		  fread(&x1, 4, 1, f);
		  fread(&y1, 4, 1, f);
		  fread(&x2, 4, 1, f);
		  fread(&y2, 4, 1, f);
		  fread(&typ, 4, 1, f);
		  statusreal(1454);
		  for(i=0;i<TERRAWAYS;i++){
			if(!terra.way[i].used){
			  statusreal(1455);
			  terra.way[i].typ=(int)typ;
			  terra.way[i].x1=x1*GEOFAC/TERRAFAC;
			  terra.way[i].y1=y1*GEOFAC/TERRAFAC;
			  terra.way[i].x2=x2*GEOFAC/TERRAFAC;
			  terra.way[i].y2=y2*GEOFAC/TERRAFAC;
			  terra.way[i].used=true;
			  statusreal(1456);
			  break;
			}
			statusreal(1457);
		  }
		  statusreal(1458);
		}
		if(typ==1024)
		{
		  fread(&fl, 4, 1, f);
		  mission.snow = (fl!=-1);
		}
		if(typ==1025)
		{
			fread(&tree[treenr].x, 4, 1, f);
			fread(&tree[treenr].y, 4, 1, f);
			fread(&tree[treenr].z, 4, 1, f);
			fread(&tree[treenr].a, 4, 1, f);
			fread(&tree[treenr].b, 4, 1, f);
			fread(&fl, 4, 1, f);
			tree[treenr].typ = (char)fl;
			fread(&fl, 4, 1, f);
			tree[treenr].used = (fl != -1);
			fread(&fl, 4, 1, f);
			tree[treenr].falling = (fl != -1);
			treenr++;
		}
		if(typ==1026)
		{
			fread(&omil[0], OMILS, sizeof(mil), f);
		}
		if(typ==1027)
		{
			fread(&shot[shotnr], 1, sizeof(tshot), f);
			shotnr++;
		}
		if(typ==1028)
		{
			fread(&part[partnr], 1, sizeof(tparticle), f);
			partnr++;
		}
		if(typ==1029)
		{
			fread(&speedgs.g, 1, sizeof(speedgs.g), f);
		}
	  }
	  statusreal(1473);
	  mission.done=false;
	  statusreal(1474);
	//  statusreal(mission.numomil);
	//  dxerror();
	  fclose(f);
	  statusreal(1475);
	  statusreal(1476);
}

void loadmission(char *fname) {
	if(strstr(fname, "save") == fname)
		loadgame(fname);
	else
	{
	  int i;
	  statusreal(1400);
	  mission.name[0]=0;
	  mission.namelen=0;
	  mission.next[0]=0;
	  mission.nextlen=0;
	  mission.light[0].x=-1;
	  mission.light[0].y=0.8f;
	  mission.light[0].z=0.4f;
	  mission.light[0].r=0;
	  mission.light[0].g=0.25f;
	  mission.light[0].b=0.75f;
	  mission.light[1].x=1;
	  mission.light[1].y=0.8f;
	  mission.light[1].z=0.4f;
	  mission.light[1].r=0.75f;
	  mission.light[1].g=0.5f;
	  mission.light[1].b=0.0f;
	  for(i=0;i<ORDERLINES;i++){
		mission.orders[i][0]=0;
		mission.orderlen[i]=0;
	  }
	  int ordlen=0;
	  int ordlines=0;
	  mission.numomil=0;
	  mission.goal.survive=-1;
	  view.px=144.5*GEOFAC;
	  view.py=144.5*GEOFAC;
	  statusreal(1401);
	  if(mission.omildesc!=NULL){
		free(mission.omildesc);
		mission.omildesc=NULL;
	  }
	  statusreal(1402);
	  FILE *f;
	  unsigned short typ;
	  statusreal(1403);
	  f=fopen(fname, "rb");
	  if(f==NULL){
		hwstatus("Mission file not found:\n");
		hwstatus(mission.fname);
		hwstatus("\n");
		dxerror();
	  }
	  statusreal(1404);
	  fseek(f, 0, SEEK_END);
	  statusreal(1405);
	  int size=ftell(f);
	  fseek(f, 0, SEEK_SET);
	  statusreal(1406);
	  while(/*!feof(f)*/ftell(f)<size){
		statusreal(1407);
		fread(&typ, 2, 1, f);
		statusreal(1408);
		float fl;
		if(typ==1){
		  statusreal(1409);
		  unsigned char c;
		  int len=1;
		  fread(&c, 1, 1, f);
	//      mission.name=(char*)malloc(40);
		  statusreal(1410);
		  mission.name[0]=c;
		  mission.name[1]=0;
		  while(c!=0){
			statusreal(1411);
			fread(&c, 1, 1, f);
			statusreal(1412);
			if(len<=STRINGLEN-2)len++;
	//        realloc(mission.name, len+1);
			mission.name[len-1]=c;
			mission.name[len]=0;
			statusreal(1413);
		  }
		  statusreal(1414);
		  mission.namelen=len-1;
		}
		statusreal(1415);
		if(typ==6){
		  unsigned char c;
		  int len=1;
		  statusreal(1416);
		  fread(&c, 1, 1, f);
		  statusreal(1417);
	//      mission.name=(char*)malloc(40);
		  mission.next[0]=c;
		  mission.next[1]=0;
		  statusreal(1418);
		  while(c!=0){
			statusreal(1419);
			fread(&c, 1, 1, f);
			statusreal(1420);
			if(len<=STRINGLEN-2)len++;
	//        realloc(mission.name, len+1);
			mission.next[len-1]=c;
			mission.next[len]=0;
			statusreal(1421);
		  }
		  statusreal(1422);
		  mission.nextlen=len-1;
		  statusreal(1423);
		}
		statusreal(1424);
		if(typ==3){
		  statusreal(1425);
		  unsigned char c;
		  fread(&c, 1, 1, f);
		  statusreal(1426);
		  ordlen++;
	//      mission.orders[ordlines]=(char*)malloc(40);
	//      else{
	//        realloc(mission.orders[ordlines], ordlen+1);
	//      }
		  mission.orders[ordlines][ordlen-1]=c;
		  mission.orders[ordlines][ordlen]=0;
		  statusreal(1427);
		  while(c!=0){
			statusreal(1428);
			fread(&c, 1, 1, f);
			statusreal(1429);
			if(ordlen<=STRINGLEN-2)ordlen++;
			statusreal(1430);
	//        mission.orders[ordlines]=realloc(mission.orders[ordlines], ordlen+1);
	//        if(mission.orders[ordlines]==NULL)memerror();
			statusreal(1431);
			mission.orders[ordlines][ordlen-1]=c;
			statusreal(1432);
			mission.orders[ordlines][ordlen]=0;
			statusreal(1433);
		  }
		  statusreal(1434);
		  mission.orderlen[ordlines]=ordlen-1;
		  statusreal(1435);
		  ordlines++;
		  ordlen=0;
		  statusreal(1436);
		}
		statusreal(1437);
		if(typ==2){
		  statusreal(1438);
		  mission.numomil++;
		  statusreal(1439);
		  if(mission.omildesc==NULL){
			statusreal(1440);
			mission.omildesc=(tomildesc*)malloc(sizeof(tomildesc));
			if(mission.omildesc==NULL)memerror();
			statusreal(1441);
		  } else {
			statusreal(1442);
			mission.omildesc=(tomildesc*)realloc(mission.omildesc, sizeof(tomildesc)*mission.numomil);
			statusreal(1443);
			if(mission.omildesc==NULL){statusreal(711);memerror();}
			statusreal(1444);
		  }
		  statusreal(1445);
		  fread(&fl, 4, 1, f);
		  statusreal(1446);
		  mission.omildesc[mission.numomil-1].owner=(int)fl;
		  statusreal(1447);
		  fread(&fl, 4, 1, f);
		  mission.omildesc[mission.numomil-1].typ=(int)fl;
		  statusreal(1448);
		  fread(&fl, 4, 1, f);
		  mission.omildesc[mission.numomil-1].posx=fl;
		  statusreal(1449);
		  fread(&fl, 4, 1, f);
		  mission.omildesc[mission.numomil-1].posy=fl;
		  statusreal(1450);
		  mission.omildesc[mission.numomil-1].target=-1;
		  mission.omildesc[mission.numomil-1].noorders=false;
		  mission.omildesc[mission.numomil-1].nogoal=false;
		  mission.omildesc[mission.numomil-1].mustsurvive=false;
		  mission.omildesc[mission.numomil-1].mustdie=false;
		  mission.omildesc[mission.numomil-1].thisisstatic=false;
		  mission.omildesc[mission.numomil-1].a=0;
		  statusreal(1451);
		}
		statusreal(1452);
		if(typ==4){
		  statusreal(1453);
		  float x1,y1,x2,y2;
		  statusreal(1454);
		  fread(&x1, 4, 1, f);
		  fread(&y1, 4, 1, f);
		  fread(&x2, 4, 1, f);
		  fread(&y2, 4, 1, f);
		  statusreal(1455);
		  for(i=0;i<TERRAWAYS;i++){
			if(!terra.way[i].used){
			  statusreal(1456);
			  terra.way[i].typ=0;
			  terra.way[i].x1=x1*GEOFAC/TERRAFAC;
			  terra.way[i].y1=y1*GEOFAC/TERRAFAC;
			  terra.way[i].x2=x2*GEOFAC/TERRAFAC;
			  terra.way[i].y2=y2*GEOFAC/TERRAFAC;
			  terra.way[i].used=true;
			  statusreal(1457);
			  break;
			}
			statusreal(1458);
		  }
		  statusreal(1459);
		}
		statusreal(1460);
		if(typ==7){
		  statusreal(1461);
		  fread(&mission.light[0].x, 4, 1, f);
		  fread(&mission.light[0].y, 4, 1, f);
		  fread(&mission.light[0].z, 4, 1, f);
		  fread(&mission.light[0].r, 4, 1, f);
		  fread(&mission.light[0].g, 4, 1, f);
		  fread(&mission.light[0].b, 4, 1, f);
		  fread(&mission.light[1].x, 4, 1, f);
		  fread(&mission.light[1].y, 4, 1, f);
		  fread(&mission.light[1].z, 4, 1, f);
		  fread(&mission.light[1].r, 4, 1, f);
		  fread(&mission.light[1].g, 4, 1, f);
		  fread(&mission.light[1].b, 4, 1, f);
		  statusreal(1462);
		}
		statusreal(1463);
		if(typ==5){
		  statusreal(1464);
		  fread(&fl, 4, 1, f);
		  mission.goal.survive=(int)fl;
		  fread(&fl, 4, 1, f);
		  mission.goal.kill=(int)fl;
		  fread(&fl, 4, 1, f);
		  mission.goal.killall=fl==-1?false:true;
		  fread(&fl, 4, 1, f);
		  mission.goal.location=fl==-1?false:true;
		  fread(&fl, 4, 1, f);
		  mission.goal.killlocation=fl==-1?false:true;
		  fread(&fl, 4, 1, f);
		  mission.goal.ban=fl==-1?false:true;
		  fread(&mission.goal.gotox, 4, 1, f);
		  fread(&mission.goal.gotoy, 4, 1, f);
		  fread(&mission.goal.radius, 4, 1, f);
		  fread(&mission.goal.killx, 4, 1, f);
		  fread(&mission.goal.killy, 4, 1, f);
		  fread(&mission.goal.killradius, 4, 1, f);
		  fread(&mission.goal.banx, 4, 1, f);
		  fread(&mission.goal.bany, 4, 1, f);
		  fread(&mission.goal.banradius, 4, 1, f);
		  mission.goal.gotox*=GEOFAC;
		  mission.goal.gotoy*=GEOFAC;
		  mission.goal.killx*=GEOFAC;
		  mission.goal.killy*=GEOFAC;
		  mission.goal.banx*=GEOFAC;
		  mission.goal.bany*=GEOFAC;
		  statusreal(1465);
		}
		if(typ==8){
		  mission.numomil++;
		  statusreal(1466);
		  if(mission.omildesc==NULL){
			statusreal(1467);
			mission.omildesc=(tomildesc*)malloc(sizeof(tomildesc));
			if(mission.omildesc==NULL)memerror();
			statusreal(1468);
		  } else {
			statusreal(1469);
			if(mission.omildesc==NULL)memerror();
			statusreal(1490);
			if((mission.omildesc=(tomildesc*)realloc(mission.omildesc, sizeof(tomildesc)*mission.numomil))==NULL)memerror();
			statusreal(1491);
		  }
		  statusreal(1471);
		  fread(&fl, 4, 1, f);
		  mission.omildesc[mission.numomil-1].owner=(int)fl;
		  fread(&fl, 4, 1, f);
		  mission.omildesc[mission.numomil-1].typ=(int)fl;
		  fread(&fl, 4, 1, f);
		  mission.omildesc[mission.numomil-1].posx=fl*GEOFAC;
		  fread(&fl, 4, 1, f);
		  mission.omildesc[mission.numomil-1].posy=fl*GEOFAC;
		  fread(&fl, 4, 1, f);
		  mission.omildesc[mission.numomil-1].target=(int)fl;
		  fread(&fl, 4, 1, f);
		  mission.omildesc[mission.numomil-1].targetx=fl*GEOFAC;
		  fread(&fl, 4, 1, f);
		  mission.omildesc[mission.numomil-1].targety=fl*GEOFAC;
		  fread(&fl, 4, 1, f);
		  mission.omildesc[mission.numomil-1].noorders=(fl==-1?false:true);
		  fread(&fl, 4, 1, f);
		  mission.omildesc[mission.numomil-1].nogoal=(fl==-1?false:true);
		  fread(&fl, 4, 1, f);
		  mission.omildesc[mission.numomil-1].mustsurvive=(fl==-1?false:true);
		  fread(&fl, 4, 1, f);
		  mission.omildesc[mission.numomil-1].mustdie=(fl==-1?false:true);
		  mission.omildesc[mission.numomil-1].thisisstatic=false;
		  mission.omildesc[mission.numomil-1].a=0;
		  statusreal(1472);
		}
		if(typ==9){
		  fread(&view.px, 4, 1, f);
		  fread(&view.py, 4, 1, f);
		  view.px*=GEOFAC;
		  view.py*=GEOFAC;
		}
		if(typ==10){
		  mission.numomil++;
		  if(mission.omildesc==NULL){
			mission.omildesc=(tomildesc*)malloc(sizeof(tomildesc));
			if(mission.omildesc==NULL)memerror();
		  } else {
			if((mission.omildesc=(tomildesc*)realloc(mission.omildesc, sizeof(tomildesc)*mission.numomil))==NULL)memerror();
		  }
		  float x,y;
		  fread(&fl, 4, 1, f);
		  mission.omildesc[mission.numomil-1].owner=(int)fl;
		  fread(&fl, 4, 1, f);
		  mission.omildesc[mission.numomil-1].typ=(int)fl;
		  fread(&x, 4, 1, f);
		  mission.omildesc[mission.numomil-1].posx=x*GEOFAC;
		  fread(&y, 4, 1, f);
		  mission.omildesc[mission.numomil-1].posy=y*GEOFAC;
		  fread(&fl, 4, 1, f);
		  mission.omildesc[mission.numomil-1].a=fl;
		  mission.omildesc[mission.numomil-1].target=-1;
		  fread(&fl, 4, 1, f);
		  mission.omildesc[mission.numomil-1].noorders=(fl==-1?false:true);
		  fread(&fl, 4, 1, f);
		  mission.omildesc[mission.numomil-1].nogoal=(fl==-1?false:true);
		  fread(&fl, 4, 1, f);
		  mission.omildesc[mission.numomil-1].mustsurvive=(fl==-1?false:true);
		  fread(&fl, 4, 1, f);
		  mission.omildesc[mission.numomil-1].mustdie=(fl==-1?false:true);
		  mission.omildesc[mission.numomil-1].thisisstatic=true;
		  statusreal(1480);
		  for(i=0;i<TERRAPLAINS;i++){
			statusreal(1481);
			if(!terra.plain[i].used){
			  statusreal(1482);
			  terra.plain[i].x=x*GEOFAC/TERRAFAC;
			  statusreal(1483);
			  terra.plain[i].y=y*GEOFAC/TERRAFAC;
			  statusreal(1484);
			  terra.plain[i].dx=6;
			  terra.plain[i].dy=6;
			  terra.plain[i].used=true;
			  statusreal(1485);
			  break;
			}
			statusreal(1486);
		  }
		  statusreal(1487);
		}
		if(typ==11){
		  statusreal(1452);
		  float x1,y1,x2,y2, typ;
		  statusreal(1453);
		  fread(&x1, 4, 1, f);
		  fread(&y1, 4, 1, f);
		  fread(&x2, 4, 1, f);
		  fread(&y2, 4, 1, f);
		  fread(&typ, 4, 1, f);
		  statusreal(1454);
		  for(i=0;i<TERRAWAYS;i++){
			if(!terra.way[i].used){
			  statusreal(1455);
			  terra.way[i].typ=(int)typ;
			  terra.way[i].x1=x1*GEOFAC/TERRAFAC;
			  terra.way[i].y1=y1*GEOFAC/TERRAFAC;
			  terra.way[i].x2=x2*GEOFAC/TERRAFAC;
			  terra.way[i].y2=y2*GEOFAC/TERRAFAC;
			  terra.way[i].used=true;
			  statusreal(1456);
			  break;
			}
			statusreal(1457);
		  }
		  statusreal(1458);
		}
	  }
	  statusreal(1473);
	  mission.done=false;
	  statusreal(1474);
	//  statusreal(mission.numomil);
	//  dxerror();
	  fclose(f);
	  statusreal(1475);
	  statusreal(1476);
	}
}
