#include "render.h"

#include "gs.h"
#include "t3_d3dbase.h"
#include "tank31fct.h"
#include "t3math.h"
#include "matrixmath.h"

void renderoverlays(void){
  int i;
  D3DBLVERTEX vx[5];
  D3DMATRIX matrix=makematrix(1,0,0,0, 0,1,0,0, 0,0,1,0, 0, 0, 0, 1);
  gs->d3d->d3ddevice->SetTransform(D3DTS_VIEW, &matrix);
  matrix=makematrix(1,0,0,0, 0,1,0,0, 0,0,1,0, 0, 0, 0, 1);
  gs->d3d->d3ddevice->SetTransform(D3DTS_PROJECTION, &matrix);
  gs->d3d->d3ddevice->SetRenderState(D3DRS_SRCBLEND, D3DBLEND_ONE);
  gs->d3d->d3ddevice->SetRenderState(D3DRS_DESTBLEND, D3DBLEND_ONE);
  if(!view.firstperson){
    for(i=0;i<OMILS;i++){
      if(omil[i].used){
        matrix=makematrix(1,0,0,0, 0,1,0,0, 0,0,1,0, omil[i].sx, omil[i].sy, 0, 1);
        gs->d3d->d3ddevice->SetTransform(D3DTS_WORLD, &matrix);
        unsigned char opy=64, nropy=64;
        if(omil[i].selected){
          if(omil[i].owner==1){
            opy=127;
            nropy=0;
          }
          gs->d3d->d3ddevice->SetTexture(0, NULL);
		  float rsize = 0.08f*(1.3f-omil[i].sy)/view.zoom*mildsc[omil[i].typ].size;
          vx[0]=makelvertex(makevector(-rsize, -rsize, 0), RGBA_MAKE(opy,nropy,nropy,opy), 0, 0);
          vx[1]=makelvertex(makevector(rsize, -rsize, 0), RGBA_MAKE(opy,nropy,nropy,opy), 1, 0);
          vx[2]=makelvertex(makevector(rsize, rsize, 0), RGBA_MAKE(opy,nropy,nropy,opy), 1, 1);
          vx[3]=makelvertex(makevector(-rsize, rsize, 0), RGBA_MAKE(opy,nropy,nropy,opy), 0, 1);
          vx[4]=makelvertex(makevector(-rsize, -rsize, 0), RGBA_MAKE(opy,nropy,nropy,opy), 0, 0);
          gs->d3d->d3ddevice->DrawPrimitiveUP(D3DPT_LINESTRIP,4,&vx[0],sizeof(D3DBLVERTEX));
        }
        // hitpoints
        int r, g;
        opy=255;
        r=(int)((1.0-omil[i].hit/omil[i].maxhit)*(float)opy);
        g=(int)((omil[i].hit/omil[i].maxhit)*(float)opy);
        gs->d3d->d3ddevice->SetTexture(0, NULL);
		float rsize = 1.0f*(1.3f-omil[i].sy)/view.zoom*mildsc[omil[i].typ].size;
        vx[0]=makelvertex(makevector(-rsize*0.08f, rsize*0.1f, 0), RGBA_MAKE(r,g,0,opy), 0, 0);
        vx[1]=makelvertex(makevector(-rsize*0.08f+rsize*0.16f*(omil[i].hit/omil[i].maxhit), rsize*0.1f, 0), RGBA_MAKE(r,g,0,opy), 1, 0);
        //gs->d3d->d3ddevice->DrawPrimitive(D3DPT_LINESTRIP,D3DBFVF_LVERTEX,&vx[0],2,0);
        gs->d3d->d3ddevice->DrawPrimitiveUP(D3DPT_LINESTRIP,1,&vx[0],sizeof(D3DBLVERTEX));
      }
    }
  }
  // mouse
  if(mouse.down && !view.firstperson){
    matrix=makematrix(1,0,0,0, 0,1,0,0, 0,0,1,0, 0, 0, 0, 1);
    gs->d3d->d3ddevice->SetTransform(D3DTS_WORLD, &matrix);
    unsigned char opy=64;
    gs->d3d->d3ddevice->SetTexture(0, NULL);
    vx[0]=makelvertex(makevector(mouse.downx, mouse.downy, 0), RGBA_MAKE(opy,opy,opy,opy), 0, 0);
    vx[1]=makelvertex(makevector((2.0f*mouse.x/gs->d3d->xres-1), mouse.downy, 0), RGBA_MAKE(opy,opy,opy,opy), 1, 0);
    vx[2]=makelvertex(makevector((2.0f*mouse.x/gs->d3d->xres-1), (1-2.0f*mouse.y/gs->d3d->yres), 0), RGBA_MAKE(opy,opy,opy,opy), 1, 1);
    vx[3]=makelvertex(makevector(mouse.downx, (1-2.0f*mouse.y/gs->d3d->yres), 0), RGBA_MAKE(opy,opy,opy,opy), 0, 1);
    vx[4]=makelvertex(makevector(mouse.downx, mouse.downy, 0), RGBA_MAKE(opy,opy,opy,opy), 0, 0);
    //gs->d3d->d3ddevice->DrawPrimitive(D3DPT_LINESTRIP,D3DBFVF_LVERTEX,&vx[0],5,0);
    gs->d3d->d3ddevice->DrawPrimitiveUP(D3DPT_LINESTRIP,4,&vx[0],sizeof(D3DBLVERTEX));
  }
  // stats
  unsigned char opy=64;
  matrix=makematrix(1,0,0,0, 0,1,0,0, 0,0,1,0, 0, 0, 0, 1);
  gs->d3d->d3ddevice->SetTransform(D3DTS_WORLD, &matrix);
#ifdef USERVIS
  for(i=0;i<USERVISNUM;i++){
    gs->d3d->d3ddevice->SetTexture(0, NULL);
    vx[0]=makelvertex(makevector(-0.98f, 0.98f-0.02f*i, 0), RGBA_MAKE(opy,opy,opy,opy), 0, 0);
    vx[1]=makelvertex(makevector(-0.98f+stats.uservis[i], 0.98f-0.02f*i, 0), RGBA_MAKE(opy,opy,opy,opy), 1, 0);
    gs->d3d->d3ddevice->DrawPrimitiveUP(D3DPT_LINESTRIP,1,&vx[0],sizeof(D3DBLVERTEX));
  }
#endif
#ifdef PROFILER
  float sum=0;
  for(i=0;i<PROFILERNUM;i++){
    sum+=stats.ptime[i];
  }
  for(i=0;i<PROFILERNUM;i++){
    if(sum!=0)stats.profiler[i]=stats.ptime[i]/sum;
    gs->d3d->d3ddevice->SetTexture(0, NULL);
    vx[0]=makelvertex(makevector(-0.98f, 0.98f-0.02f*(i+2+USERVISNUM), 0), RGBA_MAKE(opy,opy,opy,opy), 0, 0);
    vx[1]=makelvertex(makevector(-0.977f+stats.profiler[i], 0.98f-0.02f*(i+2+USERVISNUM), 0), RGBA_MAKE(opy,opy,opy,opy), 1, 0);
    gs->d3d->d3ddevice->DrawPrimitiveUP(D3DPT_LINESTRIP,1,&vx[0],sizeof(D3DBLVERTEX));
  }
#endif
  // textscreens
  gs->d3d->d3ddevice->SetRenderState(D3DRS_SRCBLEND, D3DBLEND_SRCALPHA);
  gs->d3d->d3ddevice->SetRenderState(D3DRS_DESTBLEND, D3DBLEND_INVSRCALPHA);
//  gs->d3d->d3ddevice->SetRenderState(D3DRS_BLENDENABLE, TRUE);
  gs->d3d->d3ddevice->SetRenderState(D3DRS_ALPHABLENDENABLE, TRUE);
//  gs->d3d->d3ddevice->SetRenderState( D3DRS_LIGHTING, TRUE );
  if(view.menu&&!view.firstperson){
    opy=255;
    float size=0.5;
    if(view.menutype==4||view.menutype==0)size=0.85f;
    gs->d3d->d3ddevice->SetTexture(0, dxstexture[TEXTSPACEOFF]);
    vx[0]=makelvertex(makevector(-size,  size, 0), RGBA_MAKE(opy,opy,opy,0), 0, 0);
    vx[1]=makelvertex(makevector( -0,  size, 0), RGBA_MAKE(opy,opy,opy,0), 1, 0);
    vx[2]=makelvertex(makevector(-size, 0, 0), RGBA_MAKE(opy,opy,opy,0), 0, 1);
    vx[3]=makelvertex(makevector( -0, 0, 0), RGBA_MAKE(opy,opy,opy,0), 1, 1);
    gs->d3d->d3ddevice->DrawPrimitiveUP(D3DPT_TRIANGLESTRIP,2,&vx[0],sizeof(D3DBLVERTEX));
    gs->d3d->d3ddevice->SetTexture(0, dxstexture[TEXTSPACEOFF+1]);
    vx[0]=makelvertex(makevector( 0,  size, 0), RGBA_MAKE(opy,opy,opy,0), 1/255.0f, 0);
    vx[1]=makelvertex(makevector( size,  size, 0), RGBA_MAKE(opy,opy,opy,0), 1, 0);
    vx[2]=makelvertex(makevector( 0, 0, 0), RGBA_MAKE(opy,opy,opy,0), 1/255.0f, 1);
    vx[3]=makelvertex(makevector( size, 0, 0), RGBA_MAKE(opy,opy,opy,0), 1, 1);
    gs->d3d->d3ddevice->DrawPrimitiveUP(D3DPT_TRIANGLESTRIP,2,&vx[0],sizeof(D3DBLVERTEX));
    gs->d3d->d3ddevice->SetTexture(0, dxstexture[TEXTSPACEOFF+2]);
    vx[0]=makelvertex(makevector(-size,  -0, 0), RGBA_MAKE(opy,opy,opy,0), 0, 1/255.0f);
    vx[1]=makelvertex(makevector( -0,  -0, 0), RGBA_MAKE(opy,opy,opy,0), 1, 1/255.0f);
    vx[2]=makelvertex(makevector(-size, -size, 0), RGBA_MAKE(opy,opy,opy,0), 0, 1);
    vx[3]=makelvertex(makevector( -0, -size, 0), RGBA_MAKE(opy,opy,opy,0), 1, 1);
    gs->d3d->d3ddevice->DrawPrimitiveUP(D3DPT_TRIANGLESTRIP,2,&vx[0],sizeof(D3DBLVERTEX));
    gs->d3d->d3ddevice->SetTexture(0, dxstexture[TEXTSPACEOFF+3]);
    vx[0]=makelvertex(makevector( 0,  -0, 0), RGBA_MAKE(opy,opy,opy,0), 1/255.0f, 1/255.0f);
    vx[1]=makelvertex(makevector( size,  -0, 0), RGBA_MAKE(opy,opy,opy,0), 1, 1/255.0f);
    vx[2]=makelvertex(makevector( 0, -size, 0), RGBA_MAKE(opy,opy,opy,0), 1/255.0f, 1);
    vx[3]=makelvertex(makevector( size, -size, 0), RGBA_MAKE(opy,opy,opy,0), 1, 1);
    gs->d3d->d3ddevice->DrawPrimitiveUP(D3DPT_TRIANGLESTRIP,2,&vx[0],sizeof(D3DBLVERTEX));
  }
  // fps
  opy=255;
  gs->d3d->d3ddevice->SetTexture(0, dxstexture[TEXTSPACE2OFF]);
  vx[0]=makelvertex(makevector(0.85f, 0.98f, 0), RGBA_MAKE(opy,opy,opy,0), 0, 0);
  vx[1]=makelvertex(makevector(0.98f, 0.98f, 0), RGBA_MAKE(opy,opy,opy,0), 0.4f, 0);
  vx[2]=makelvertex(makevector(0.85f, 0.93f, 0), RGBA_MAKE(opy,opy,opy,0), 0, 0.09f);
  vx[3]=makelvertex(makevector(0.98f, 0.93f, 0), RGBA_MAKE(opy,opy,opy,0), 0.4f, 0.09f);
    gs->d3d->d3ddevice->DrawPrimitiveUP(D3DPT_TRIANGLESTRIP,2,&vx[0],sizeof(D3DBLVERTEX));
  // add
  gs->d3d->d3ddevice->SetRenderState(D3DRS_SRCBLEND, D3DBLEND_ONE);
  gs->d3d->d3ddevice->SetRenderState(D3DRS_DESTBLEND, D3DBLEND_ONE);
  // mouse
    opy=128;
    float mx=(float)(mouse.x*2)/gs->d3d->xres-1;
    float my=1-(float)(mouse.y*2)/gs->d3d->yres;
    gs->d3d->d3ddevice->SetTexture(0, dxstexture[TEXTSPACE2OFF]);
    vx[0]=makelvertex(makevector(mx, my, 0), RGBA_MAKE(opy,opy,opy,0), 0, 0.1f);
    vx[1]=makelvertex(makevector(mx+0.05f, my, 0), RGBA_MAKE(opy,opy,opy,0), 0.05f, 0.1f);
    vx[2]=makelvertex(makevector(mx, my-0.05f, 0), RGBA_MAKE(opy,opy,opy,0), 0, 0.15f);
    vx[3]=makelvertex(makevector(mx+0.05f, my-0.05f, 0), RGBA_MAKE(opy,opy,opy,0), 0.05f, 0.15f);
    gs->d3d->d3ddevice->DrawPrimitiveUP(D3DPT_TRIANGLESTRIP,2,&vx[0],sizeof(D3DBLVERTEX));
  // intro
  if(view.firstperson){
    if(speedgs.g<2){
      opy=(int)(128*speedgs.g);
      if(opy>255)opy=255;
    }
    if(speedgs.g>=2&&speedgs.g<4){
      opy=255;
    }
    if(speedgs.g>=4&&speedgs.g<6){
      opy=255-(int)(128*(speedgs.g-4));
    }
    if(speedgs.g>=6&&speedgs.g<8){
      opy=(int)(128*(speedgs.g-6));
      if(opy>255)opy=255;
    }
    if(speedgs.g>=8&&speedgs.g<10){
      opy=255;
    }
    if(speedgs.g>=10&&speedgs.g<12){
      opy=255-(int)(128*(speedgs.g-10));
    }
    if(speedgs.g>=12){
      opy=0;
    }
    gs->d3d->d3ddevice->SetTexture(0, dxstexture[TEXTSPACEOFF]);
    vx[0]=makelvertex(makevector(-0.9f, 0.4f, 0), RGBA_MAKE(opy,opy,opy,0), 0, 0);
    vx[1]=makelvertex(makevector(0, 0.4f, 0), RGBA_MAKE(opy,opy,opy,0), 1, 0);
    vx[2]=makelvertex(makevector(-0.9f, -0.4f, 0), RGBA_MAKE(opy,opy,opy,0), 0, 1);
    vx[3]=makelvertex(makevector(0, -0.4f, 0), RGBA_MAKE(opy,opy,opy,0), 1, 1);
    gs->d3d->d3ddevice->DrawPrimitiveUP(D3DPT_TRIANGLESTRIP,2,&vx[0],sizeof(D3DBLVERTEX));
    gs->d3d->d3ddevice->SetTexture(0, dxstexture[TEXTSPACEOFF+1]);
    vx[0]=makelvertex(makevector(0, 0.4f, 0), RGBA_MAKE(opy,opy,opy,0), 0, 0);
    vx[1]=makelvertex(makevector(0.9f, 0.4f, 0), RGBA_MAKE(opy,opy,opy,0), 1, 0);
    vx[2]=makelvertex(makevector(0, -0.4f, 0), RGBA_MAKE(opy,opy,opy,0), 0, 1);
    vx[3]=makelvertex(makevector(0.9f, -0.4f, 0), RGBA_MAKE(opy,opy,opy,0), 1, 1);
    gs->d3d->d3ddevice->DrawPrimitiveUP(D3DPT_TRIANGLESTRIP,2,&vx[0],sizeof(D3DBLVERTEX));
  }
  // restore
  gs->d3d->d3ddevice->SetRenderState(D3DRS_SRCBLEND, D3DBLEND_SRCALPHA);
  gs->d3d->d3ddevice->SetRenderState(D3DRS_DESTBLEND, D3DBLEND_INVSRCALPHA);
  gs->d3d->d3ddevice->SetTransform(D3DTS_VIEW, &viewmtx);
  gs->d3d->d3ddevice->SetTransform(D3DTS_PROJECTION, &projmtx);
}

void render(void){
  int i;
  status(200);
  startprofile(3);
  // clear zbuf, backbuf
  //ZeroMemory(&dxblt, sizeof(dxblt));
  //dxblt.dwSize = sizeof(dxblt);
  D3DCOLOR fillcolor;
  gs->d3d->d3ddevice->SetRenderState(D3DRS_LIGHTING,FALSE); 
/*  gs->d3d->d3ddevice->SetRenderState(D3DRS_ALPHABLENDENABLE, FALSE);
  gs->d3d->d3ddevice->SetRenderState(D3DRS_ZWRITEENABLE,TRUE);
  gs->d3d->d3ddevice->SetRenderState(D3DRS_SRCBLEND, D3DBLEND_SRCALPHA);//SRCCOLOR
  gs->d3d->d3ddevice->SetRenderState(D3DRS_DESTBLEND, D3DBLEND_ZERO);//INVSRCCOLOR*/
  if(view.firstperson){
    if(BITS==16){
      fillcolor=0x841F;
    } else {
      fillcolor=0x80B0FF;
    }
  } else {
    if(BITS==16){
      fillcolor=0x400;
    } else {
      fillcolor=0x008000;
    }
  }
  status(201);
/*  if(view.firstperson){
    if(dxbackbuffer->Blt(NULL,NULL,NULL,DDBLT_COLORFILL,&dxblt)!=D3D_OK) dxerror();
  }*/
  status(202);
  D3DRECT rect;
  rect.x1 = 0;rect.y1 = 0;
  rect.x2 = XRES; rect.y2 = YRES;
  status(203);
//  if(gs->d3dviewport->Clear(1, &rect, D3DCLEAR_ZBUFFER)!=D3D_OK) dxerror();
  if(view.firstperson)
	  gs->d3d->d3ddevice->Clear(0, NULL, D3DCLEAR_ZBUFFER | D3DCLEAR_TARGET, fillcolor, ZBCLEARVALUE, 0);
  else
	  gs->d3d->d3ddevice->Clear(0, NULL, D3DCLEAR_ZBUFFER, fillcolor, ZBCLEARVALUE, 0);
  gs->d3d->d3ddevice->SetRenderState(D3DRS_LIGHTING,TRUE); 
  stopprofile(3);
  // projection
  if(view.firstperson){
    matrix=makematrix(1,0,0,0, 0,1,0,0, 0,0,0.04f,0, 0,0,0.6f,1);
    gs->d3d->d3ddevice->SetTransform(D3DTS_PROJECTION, &matrix);
    matrix=makematrix(1/view.zoom,0,0,0, 0,1/view.zoom,0,0, 0,0,1,0, 0,0,0,1);
    gs->d3d->d3ddevice->MultiplyTransform(D3DTS_PROJECTION, &matrix);
  } else {
    matrix=makematrix(1,0,0,0, 0,1,0,0, 0,0,0.04f,0, 0,0,0.6f,1);
    gs->d3d->d3ddevice->SetTransform(D3DTS_PROJECTION, &matrix);
    matrix=makematrix(1/view.zoom,0,0,0, 0,1/view.zoom,0,0, 0,0,1,0, 0,0,0,1);
    gs->d3d->d3ddevice->MultiplyTransform(D3DTS_PROJECTION, &matrix);
  }
  matrix=makematrix(1*2,0,0,0, 0,1*2,0,0, 0,0,1*2,1, 0,0,0*2,1);
  gs->d3d->d3ddevice->MultiplyTransform(D3DTS_PROJECTION, &matrix);
  if(view.firstperson){
    matrix=makematrix(1,0,0,0, 0,1,0,0, 0,0,ZMULT*0+1,0, 0,0,ZADD,1);
    gs->d3d->d3ddevice->MultiplyTransform(D3DTS_PROJECTION, &matrix);
  } else {
    matrix=makematrix(1,0,0,0, 0,1,0,0, 0,0,ZMULT*0+1,0, 0,0,ZADD,1);
    gs->d3d->d3ddevice->MultiplyTransform(D3DTS_PROJECTION, &matrix);
  }
  gs->d3d->d3ddevice->GetTransform(D3DTS_PROJECTION, &matrix);
/*  matrix._11/=matrix._34;
  matrix._22/=matrix._34;
  matrix._33/=matrix._34;
  matrix._43/=matrix._34;*/
//  matrix._14=0;
//  matrix._24=0;
//  matrix._14=0;
//  matrix._24=0;
  matrix._34=1;
//  matrix._44=0;
//  matrix._44=0;
//  matrix._44=0;
/*  matrix(1,4)=0;
  matrix(2,4)=0;
  matrix(3,4)=1;
  matrix(4,4)=0;*/
  gs->d3d->d3ddevice->SetTransform(D3DTS_PROJECTION, &matrix);
  gs->d3d->d3ddevice->GetTransform(D3DTS_PROJECTION, &projmtx);
  // view
  status(204);
  if(view.firstperson){
    matrix=makematrix(1,0,0,0, 0,tcos(PI/4+0.67f),tsin(PI/4+0.67f),0, 0,-tsin(PI/4+0.67f),tcos(PI/4+0.67f),0, 0,0,0,1);
    gs->d3d->d3ddevice->SetTransform(D3DTS_VIEW, &matrix);
    matrix=makematrix(1,0,0,0, 0,1,0,0, 0,0,1,0, 0,-1.13f,0.57f+0.08f*MAXHEIGHT,1);
    gs->d3d->d3ddevice->MultiplyTransform(D3DTS_VIEW, &matrix);
    matrix=makematrix(1,0,0,0, 0,1,0,0, 0,0,1,0, -view.px,-view.py,0,VIEWDIV-4.32f);
    gs->d3d->d3ddevice->MultiplyTransform(D3DTS_VIEW, &matrix);
  } else {
    matrix=makematrix(1,0,0,0, 0,tcos(PI/4),tsin(PI/4),0, 0,-tsin(PI/4),tcos(PI/4),0, 0,0,0,1);
    gs->d3d->d3ddevice->SetTransform(D3DTS_VIEW, &matrix);
    matrix=makematrix(1,0,0,0, 0,1,0,0, 0,0,1,0, 0,0.4f,0,1);
    gs->d3d->d3ddevice->MultiplyTransform(D3DTS_VIEW, &matrix);
    matrix=makematrix(1,0,0,0, 0,1,0,0, 0,0,1,0, -view.px,-view.py,0,VIEWDIV+4.09f);
    gs->d3d->d3ddevice->MultiplyTransform(D3DTS_VIEW, &matrix);
  }
  gs->d3d->d3ddevice->GetTransform(D3DTS_VIEW, &viewmtx);
  // precalculate direction basis
  gs->d3d->d3ddevice->MultiplyTransform(D3DTS_PROJECTION, &viewmtx);
  gs->d3d->d3ddevice->GetTransform(D3DTS_PROJECTION, &vpmtx);
  gs->d3d->d3ddevice->SetTransform(D3DTS_PROJECTION, &projmtx);
/*  matrix=makematrix(1,0,0,0, 0,1,0,0, 0,0,1,0, 0,-1,0,1);
  gs->d3d->d3ddevice->MultiplyTransform(D3DTS_VIEW, &matrix);*/
//  view.px+=0.03;
  status(205);
  // draw scene
  if (gs->d3d->d3ddevice->BeginScene()==D3D_OK)
  {
	  status(217);
	//  gs->d3d->d3ddevice->SetRenderState(D3DRS_TEXTUREADDRESS, D3DTADDRESS_CLAMP);
	  startprofile(12);
	  status(218);
	  status(219);
	  gs->d3d->d3ddevice->SetVertexShader( D3DBFVF_LVERTEX );
	  gs->d3d->d3ddevice->SetRenderState(D3DRS_LIGHTING, FALSE );
	  renderterra();
	  gs->d3d->d3ddevice->SetRenderState(D3DRS_LIGHTING, TRUE );
	  status(220);
	//  gs->d3d->d3ddevice->SetRenderState(D3DRS_TEXTUREADDRESS, D3DTADDRESS_WRAP);
	  stopprofile(12);
	  status(221);
	  status(206);
	  startprofile(4);
	  gs->d3d->d3ddevice->SetVertexShader( D3DBFVF_VERTEX );
	  for(i=0;i<OMILS;i++){
		if(omil[i].used){
		  rendermil(&(omil[i]));
		}
	  }
	/*  gs->d3d->d3ddevice->SetRenderState( D3DRS_ALPHATESTENABLE, TRUE );
	  gs->d3d->d3ddevice->SetRenderState( D3DRS_ALPHAREF, (DWORD)0x00202020);
	  gs->d3d->d3ddevice->SetRenderState( D3DRS_ALPHAFUNC, D3DCMP_GREATEREQUAL ); 
	  gs->d3d->d3ddevice->SetRenderState(D3DRS_COLORKEYENABLE, TRUE);*/
	//  gs->d3d->d3ddevice->SetRenderState(D3DRS_ALPHABLENDENABLE, TRUE);
	//  gs->d3d->d3ddevice->SetRenderState(D3DRS_BLENDENABLE, TRUE);
	  // dead omils
	//  gs->d3d->d3ddevice->SetRenderState(D3DRS_COLORKEYENABLE, FALSE);
	//  gs->d3d->d3ddevice->SetRenderState(D3DRS_BLENDENABLE, FALSE);
	//  gs->d3d->d3ddevice->SetRenderState(D3DRS_ALPHABLENDENABLE, FALSE);
	//  gs->d3d->d3ddevice->SetRenderState( D3DRS_ALPHATESTENABLE, FALSE );
	  stopprofile(4);
	  startprofile(5);
	  status(208);
	  for(i=0;i<NUMSHOTS;i++){
		if(shot[i].used){
		  rendershot(i);
		}
	  }
	  stopprofile(5);
	  status(210);
	//  gs->d3d->d3ddevice->SetRenderState(D3DRS_COLORKEYBLENDENABLE, TRUE);
	//  gs->d3d->d3ddevice->SetRenderState(D3DRS_COLORKEYENABLE, FALSE);
	//  gs->d3d->d3ddevice->SetRenderState( D3DRS_ALPHATESTENABLE, FALSE ); 
	//  gs->d3d->d3ddevice->SetRenderState(D3DRS_COLORKEYBLENDENABLE, FALSE);
	//  gs->d3d->d3ddevice->SetRenderState(D3DRS_ALPHABLENDENABLE, TRUE);
	  gs->d3d->d3ddevice->SetRenderState(D3DRS_ALPHABLENDENABLE, TRUE);
	//  gs->d3d->d3ddevice->SetRenderState(D3DRS_BLENDENABLE, TRUE);
	  status(211);
	  // transparent surfaces at last!
	  // Particles
	  gs->d3d->d3ddevice->SetRenderState(D3DRS_LIGHTING, TRUE );
	/*  gs->d3d->d3ddevice->SetRenderState(D3DRS_ALPHATESTENABLE, TRUE );
	  gs->d3d->d3ddevice->SetRenderState(D3DRS_ALPHAREF, (DWORD)0x00808080);
	  gs->d3d->d3ddevice->SetRenderState(D3DRS_ALPHAFUNC, D3DCMP_GREATEREQUAL ); 
	  gs->d3d->d3ddevice->SetRenderState(D3DRS_COLORKEYENABLE, TRUE);*/
	  startprofile(6);
	  gs->d3d->d3ddevice->SetRenderState(D3DRS_ZWRITEENABLE,FALSE);
	  rendertrees(true);
	  stopprofile(6);
	  gs->d3d->d3ddevice->SetRenderState(D3DRS_SRCBLEND, D3DBLEND_SRCALPHA);//SRCCOLOR
	  gs->d3d->d3ddevice->SetRenderState(D3DRS_DESTBLEND, D3DBLEND_INVSRCALPHA);//INVSRCCOLOR
	  startprofile(4);
	  for(i=0;i<OMILS;i++){
		if(omil[i].dead){
		  rendermil(&(omil[i]));
		}
	  };
	  stopprofile(4);
	  startprofile(11);
	  gs->d3d->d3ddevice->SetRenderState(D3DRS_LIGHTING, FALSE );
	  gs->d3d->d3ddevice->SetVertexShader( D3DBFVF_LVERTEX );
	  renderparticles(true);
	  gs->d3d->d3ddevice->SetRenderState(D3DRS_ZWRITEENABLE,TRUE);
	  renderparticles(false);
	  stopprofile(11);
	  startprofile(6);
	  gs->d3d->d3ddevice->SetRenderState(D3DRS_LIGHTING, TRUE );
	  gs->d3d->d3ddevice->SetVertexShader( D3DBFVF_VERTEX );
	  rendertrees(true);
	  stopprofile(6);
	  startprofile(4);
	  gs->d3d->d3ddevice->SetRenderState(D3DRS_SRCBLEND, D3DBLEND_SRCALPHA);//SRCCOLOR
	  gs->d3d->d3ddevice->SetRenderState(D3DRS_DESTBLEND, D3DBLEND_INVSRCALPHA);//INVSRCCOLOR
	  for(i=0;i<OMILS;i++){
		if(omil[i].dead){
		  rendermil(&(omil[i]));
		}
	  }
	  stopprofile(4);
	//  gs->d3d->d3ddevice->SetRenderState(D3DRS_ZFUNC,D3DCMP_ALWAYS);
	/*  gs->d3d->d3ddevice->SetRenderState(D3DRS_ALPHATESTENABLE, FALSE );
	  gs->d3d->d3ddevice->SetRenderState(D3DRS_COLORKEYENABLE, FALSE);*/
	//  gs->d3d->d3ddevice->SetRenderState(D3DRS_ZFUNC,D3DCMP_LESS);
	  gs->d3d->d3ddevice->SetRenderState(D3DRS_LIGHTING, FALSE );
	  gs->d3d->d3ddevice->SetRenderState(D3DRS_ZWRITEENABLE,FALSE);
	//  renderparticles(true);
	  status(213);
	  gs->d3d->d3ddevice->SetRenderState(D3DRS_ZWRITEENABLE,TRUE);
	  gs->d3d->d3ddevice->SetRenderState(D3DRS_ZFUNC,D3DCMP_ALWAYS);
	  gs->d3d->d3ddevice->SetVertexShader( D3DBFVF_LVERTEX );
	  renderoverlays();// no profiles over this!!
	  gs->d3d->d3ddevice->SetRenderState(D3DRS_ZFUNC,STDCOMPFUNC);
	  gs->d3d->d3ddevice->SetRenderState( D3DRS_LIGHTING, TRUE );
	  gs->d3d->d3ddevice->SetRenderState(D3DRS_ZWRITEENABLE,TRUE);
	//  gs->d3d->d3ddevice->SetRenderState(D3DRS_BLENDENABLE, FALSE);
	  // Trees 2
	  gs->d3d->d3ddevice->SetRenderState(D3DRS_ALPHABLENDENABLE, FALSE);
	  status(214);
	  gs->d3d->d3ddevice->EndScene();
  }
  if(view.changedr)
  {
	  view.changedr = false;
	  view.changed = true;
  }
  else
	  view.changed = false;
  // flip buffers
  status(215);
  startprofile(7);
  gs->d3d->d3ddevice->Present( NULL, NULL, NULL, NULL );
//  if(dxprimary->Flip(NULL,DDFLIP_NOVSYNC)!=D3D_OK)dxerror();//DDFLIP_NOVSYNC DDFLIP_WAIT
  status(216);
  stopprofile(7);
}
