#include "sound.h"
#include "tank31fct.h"
#include "gs.h"
#include "t3_d3dbase.h"

#include <stdio.h>

// DirectSound
LPDIRECTSOUND8 dxsound;// main directsound handle
LPDIRECTSOUNDBUFFER dxsoundbuffer[SOUNDS*PARSOUNDS];// sound buffers
LPDIRECTSOUNDBUFFER dxonesoundbuffer[ONESOUNDS];// one-time sound buffers
char* dxssbuf[SOUNDS];// backup buffers
int dxssbuflen[SOUNDS];// buffer lengths
// time indices to prevent chaos when playing many sounds
float lastplayed[SOUNDS];
bool dxsoundok;// sound init was successful

////////////////// play //////////////////////////
// play a sound
void play(int num){
#ifndef DISABLESOUND
  if(speedgs.g-lastplayed[num]>=SOUNDINTERVAL&&dxsoundok){
    lastplayed[num]=speedgs.g;
    DWORD WAVStatus;
    for(int i=0;i<PARSOUNDS;i++){
      if(dxsoundbuffer[num*PARSOUNDS+i]->GetStatus(&WAVStatus)!=D3D_OK)dxerror();
      if((WAVStatus&DSBSTATUS_BUFFERLOST)==DSBSTATUS_BUFFERLOST){
        hwstatus("Soundbuffer lost at play()\n");
        if(dxsoundbuffer[num*PARSOUNDS+i]->Restore()!=D3D_OK){
          hwstatus("Soundbuffer Restore() failed\n");
        } else {
          hwstatus("Soundbuffer Restore() successful\n");
        }
      }
      if((WAVStatus&DSBSTATUS_PLAYING)!=DSBSTATUS_PLAYING
      &&(WAVStatus&DSBSTATUS_BUFFERLOST)!=DSBSTATUS_BUFFERLOST
      &&(WAVStatus&DSBSTATUS_TERMINATED)!=DSBSTATUS_TERMINATED){
        //if(dxsound->DuplicateSoundBuffer(dxsoundbuffer[num*PARSOUNDS],&dxsoundbuffer[num*PARSOUNDS+i])!=D3D_OK)dxerror();
        if(dxsoundbuffer[num*PARSOUNDS+i]->SetCurrentPosition(0)!=D3D_OK)dxerror();
        if(dxsoundbuffer[num*PARSOUNDS+i]->Play(0,0,0)!=D3D_OK)dxerror();
        break;
      }
    }
  }
#endif
}

/////////////////////////// playone ////////////////////
// play a one-time-sound
void playone(int num){
#ifndef DISABLESOUND
  if(dxsoundok){
    status(2400);
    DWORD WAVStatus;
    status(2401);
    if(dxonesoundbuffer[num]->GetStatus(&WAVStatus)!=D3D_OK)dxerror();
    status(2402);
    if(WAVStatus!=DSBSTATUS_PLAYING){
      status(2403);
      if(dxonesoundbuffer[num]->SetCurrentPosition(0)!=D3D_OK)dxerror();
      if(dxonesoundbuffer[num]->Play(0,0,0)!=D3D_OK)dxerror();
      status(2404);
    }
    status(2405);
  }
#endif
}

void LoadDirectSound(LPDIRECTSOUNDBUFFER *buffer, char* filename)
{
    FILE *f;
    PCMWAVEFORMAT pcmwf;
    DSBUFFERDESC dsbdesc;
    int flen;
	void *write1=NULL;
    f=fopen(filename, "rb");
//    if(f==NULL)goto out;
    fseek(f, 0, SEEK_END);
    flen=ftell(f);
    if(flen<=0)goto out;
    fseek(f, 0, SEEK_SET);
    statusreal(908);
    // Set up wave format structure. 
    memset(&pcmwf, 0, sizeof(PCMWAVEFORMAT)); 
    pcmwf.wf.wFormatTag = WAVE_FORMAT_PCM; 
    pcmwf.wf.nChannels = 1; 
    pcmwf.wf.nSamplesPerSec = 8000; 
    pcmwf.wf.nBlockAlign = 1;
    pcmwf.wf.nAvgBytesPerSec = pcmwf.wf.nSamplesPerSec*pcmwf.wf.nBlockAlign; 
    pcmwf.wBitsPerSample = 8; 
    // Set up DSBUFFERDESC structure. 
    memset(&dsbdesc, 0, sizeof(DSBUFFERDESC)); // Zero it out. 
    dsbdesc.dwSize = sizeof(DSBUFFERDESC); 
    // Need default controls (pan, volume, frequency). 
    dsbdesc.dwFlags = 0; //DSBCAPS_CTRLPAN | DSBCAPS_CTRLVOLUME | DSBCAPS_CTRLFREQUENCY; 
    // buffer. 
    dsbdesc.dwBufferBytes = flen;//min(flen, pcmwf.wf.nAvgBytesPerSec);//3 * pcmwf.wf.nAvgBytesPerSec; 
    dsbdesc.lpwfxFormat = (LPWAVEFORMATEX)&pcmwf; 
    // Create buffer. 
    if(dxsound->CreateSoundBuffer(&dsbdesc, buffer, NULL)!=D3D_OK)goto out;//goto out;

    statusreal(910);
	//write wave data to directsound buffer you just created
	unsigned long length1;
    status(911);
	if(((*buffer)->Lock(0,flen,&write1,&length1,NULL,NULL,DSBLOCK_ENTIREBUFFER ))!=D3D_OK)goto out;//goto out;
    status(912);
    status(913);
    fread(write1, min((long)length1, flen), 1, f);
    status(914);
    fclose(f);
    status(915);
	if((*buffer)->Unlock(write1,length1,0,0)!=D3D_OK)dxerror();
    status(916);
    goto outover;
    out:;
    dxsoundok=false;
    outover:;
}

void loadsounds(void)
{
  int i;
  LoadDirectSound(&dxsoundbuffer[0*PARSOUNDS], "sounds\\bumm.wav");
  for(i=1;i<PARSOUNDS;i++)if(dxsound->DuplicateSoundBuffer(dxsoundbuffer[0],&dxsoundbuffer[i])!=D3D_OK)dxerror();
  LoadDirectSound(&dxsoundbuffer[1*PARSOUNDS], "sounds\\expl.wav");
  for(i=1;i<PARSOUNDS;i++)if(dxsound->DuplicateSoundBuffer(dxsoundbuffer[PARSOUNDS],&dxsoundbuffer[PARSOUNDS+i])!=D3D_OK)dxerror();
  LoadDirectSound(&dxsoundbuffer[2*PARSOUNDS], "sounds\\mg.wav");
  for(i=1;i<PARSOUNDS;i++)if(dxsound->DuplicateSoundBuffer(dxsoundbuffer[2*PARSOUNDS],&dxsoundbuffer[2*PARSOUNDS+i])!=D3D_OK)dxerror();
  LoadDirectSound(&dxsoundbuffer[3*PARSOUNDS], "sounds\\art.wav");
  for(i=1;i<PARSOUNDS;i++)if(dxsound->DuplicateSoundBuffer(dxsoundbuffer[3*PARSOUNDS],&dxsoundbuffer[3*PARSOUNDS+i])!=D3D_OK)dxerror();
  // one time-sounds
  LoadDirectSound(&dxonesoundbuffer[0],"sounds\\seals.wav");
}

void dsoundinit()
{
    dxsoundok=true;
	//get directsound interface
    statusreal(903);
	if(DirectSoundCreate8(NULL,&dxsound,NULL)==D3D_OK){
      statusreal(904);
	  //setcooperativelevel of interface
      statusreal(905);
  	  if(dxsound->SetCooperativeLevel(gs->d3d->hwnd,DSSCL_NORMAL)==D3D_OK){
        statusreal(906);
        loadsounds();
      } else {
        dxsoundok=false;
      }
    } else {
      dxsoundok=false;
    }
    statusreal(907);
}
