#include "t3math.h"

#include <math.h>

// sinus tables for faster execution (not fully implemented yet)
float sintable[65536];
float costable[65536];

////////////////// begr //////////////////////
// basically it's a modulo function (x%y), but with corrected
// behavior with negative values. y must be != 0

///////////////// init sinus tables ////////////////
// used to initialize the sine and cosine tables
// angles are in 0..65535 range
void inittables(void){
  for(int i=0;i<65536;i++){
    sintable[i]=(float)sin(((float)i)*2*PI/65536);
    costable[i]=(float)cos(((float)i)*2*PI/65536);
  }
}

///////////////////////// begrf //////////////////////
// modulo for floats
float begrf(float x, float ber){
  if(ber>0){
    while(x<0)x+=ber;
    while(x>=ber)x-=ber;
    return x;
  }else{
    return 0;
  }
}
