
#include "terra.h"

#include "mission.h"
#include "t3math.h"
#include "matrixmath.h"

#include <time.h>
#include <sys/timeb.h>

tterrain terra;

//////////////// init green //////////////////////
// init the green or the snow textures
void initgreen(void){
	int i, j, k, l;
	D3DLOCKED_RECT lrect, lrect2;
  for(i=0;i<TEXX;i++){
    for(j=0;j<TEXY;j++){
      if(dxstexture[TEXSPACEOFF+j*TEXX+i]->LockRect( 0, &lrect, NULL, 0 )!=D3D_OK)dxerror();
      unsigned int *texbuf=(unsigned int*)lrect.pBits;
      unsigned short *texbufw=(unsigned short*)lrect.pBits;
      if(lrect.pBits==NULL){statusreal(702);dxerror();}
      statusreal(503);
      if(!mission.snow){
        for(k=0;k<TXRES;k++){
          for(l=0;l<TYRES;l++){
              texbuf[l*TXRES+k]=(128+rand()%128)<<8;
          }
        }
          texbuf[(TYRES-1)*TXRES+TXRES-1]=0x00008000;
          texbuf[(0)*TXRES+TXRES-1]=0x00008000;
          texbuf[(0)*TXRES+0]=0x00008000;
          texbuf[(TYRES-1)*TXRES+0]=0x00008000;
      } else {
        for(k=0;k<TXRES;k++){
          for(l=0;l<TYRES;l++){
              unsigned char col=192+rand()%64;
              texbuf[l*TXRES+k]=(col<<16)+(col<<8)+col;
          }
        }
          texbuf[(TYRES-1)*TXRES+TXRES-1]=0x00C0C0C0;
          texbuf[(0)*TXRES+TXRES-1]=0x00C0C0C0;
          texbuf[(0)*TXRES+0]=0x00C0C0C0;
          texbuf[(TYRES-1)*TXRES+0]=0x00C0C0C0;
      }    
      statusreal(504);
      if(dxstexture[TEXSPACEOFF+j*TEXX+i]->UnlockRect(0)!=D3D_OK)dxerror();
      statusreal(505);
    }
  }
  statusreal(1200);
  unsigned int color;
  statusreal(1201);
  for(i=0;i<TEXX;i++){
    for(j=0;j<TEXY;j++){
      for(k=0;k<TXRES;k++){
        if(i==0&&j==0&&k==0){statusreal(1202);}
        if(i==0&&j==0&&k==0){statusreal(1203);}
        if(i==0&&j==0&&k==0){statusreal(1204);}
        if(dxstexture[TEXSPACEOFF+j*TEXX+i]->LockRect( 0, &lrect, NULL, 0 )!=D3D_OK)dxerror();
        if(i==0&&j==0&&k==0){statusreal(1205);}
        unsigned int *texbuf=(unsigned int*)lrect.pBits;
        if(i==0&&j==0&&k==0){statusreal(1206);}
        if(lrect.pBits==NULL){statusreal(703);dxerror();}
        if(i==0&&j==0&&k==0){statusreal(1207);}
        if(i==0&&j==0&&k==0){statusreal(1208);}
        if(i==0&&j==0&&k==0){statusreal(1209);}
        if(dxstexture[TEXSPACEOFF+j*TEXX+begr(i+1, TEXX)]->LockRect( 0, &lrect2, NULL, 0 )!=D3D_OK)dxerror();
        if(i==0&&j==0&&k==0){statusreal(1210);}
        unsigned int *texbuf2=(unsigned int*)lrect2.pBits;
        if(i==0&&j==0&&k==0){statusreal(1211);}
        if(lrect2.pBits==NULL){statusreal(704);dxerror();}
        if(i==0&&j==0&&k==0){statusreal(1212);}
          if(i==0&&j==0&&k==0){statusreal(1216);}
          color=texbuf2[k*TXRES+0];
          if(i==0&&j==0&&k==0){statusreal(1217);}
          texbuf[k*TXRES+TXRES-1]=color;
          if(i==0&&j==0&&k==0){statusreal(1218);}
        if(i==0&&j==0&&k==0){statusreal(1219);}
        if(dxstexture[TEXSPACEOFF+j*TEXX+begr(i+1, TEXX)]->UnlockRect(0)!=D3D_OK)dxerror();
        if(i==0&&j==0&&k==0){statusreal(1220);}
        if(i==0&&j==0&&k==0){statusreal(1221);}
        if(i==0&&j==0&&k==0){status(1222);}
        if(dxstexture[TEXSPACEOFF+begr(j+1,TEXY)*TEXX+i]->LockRect( 0, &lrect, NULL, 0 )!=D3D_OK)dxerror();
        if(i==0&&j==0&&k==0){statusreal(1223);}
        texbuf2=(unsigned int*)lrect2.pBits;
        if(i==0&&j==0&&k==0){statusreal(1224);}
        if(lrect2.pBits==NULL){statusreal(705);dxerror();}
        if(i==0&&j==0&&k==0){statusreal(1225);}
          if(i==0&&j==0&&k==0){statusreal(1229);}
          color=texbuf2[k];
          if(i==0&&j==0&&k==0){statusreal(1230);}
          texbuf[TXRES*(TYRES-1)+k]=color;
          if(i==0&&j==0&&k==0){statusreal(1231);}
        if(i==0&&j==0&&k==0){statusreal(1232);}
        if(dxstexture[TEXSPACEOFF+begr(j+1, TEXY)*TEXX+i]->UnlockRect(0)!=D3D_OK)dxerror();
        if(i==0&&j==0&&k==0){statusreal(1233);}
        if(dxstexture[TEXSPACEOFF+j*TEXX+i]->UnlockRect(0)!=D3D_OK)dxerror();
        if(i==0&&j==0&&k==0){statusreal(1234);}
      }
      if(i==0&&j==0){statusreal(1235);}
    }
    if(i==0){statusreal(1236);}
  }
  statusreal(1237);
}

////////////////// terra textures //////////////////
// Create the terra textures
void initterratex(void){
  int i, j;
  for(i=0;i<TEXX;i++){
    for(j=0;j<TEXY;j++){
		gs->d3d->d3ddevice->CreateTexture(TXRES, TYRES, 1, 0, D3DFMT_A8R8G8B8, D3DPOOL_MANAGED, &dxstexture[TEXSPACEOFF+j*TEXX+i]);
    }
  }
  statusreal(507);
  initgreen();
}

float crosslight(D3DVECTOR a, D3DVECTOR b)
{
	float r = a.x*b.x + a.y*b.y + a.z*b.z;
	r /= -(float)sqrt(a.x*a.x + a.y*a.y + a.z*a.z) * (float)sqrt(b.x*b.x + b.y*b.y + b.z*b.z);
	return (r>0?r:0);
}

void addpixel(float x,float y){
  int i=begr(toint(x), FIELDX)*TEXX/FIELDX;
  int j=begr(toint(y), FIELDY)*TEXY/FIELDY;
  D3DLOCKED_RECT lrect;
  unsigned int color;
  int br=begr(rand(),63)+1,bg=begr(rand(),br)+1,bb=begr(rand(),bg)+1;
  int r, g, b;
  int tx, ty;
  if(dxstexture[TEXSPACEOFF+j*TEXX+i]->LockRect( 0, &lrect, NULL, 0 )!=D3D_OK)dxerror();
  unsigned int *texbuf=(unsigned int*)lrect.pBits;
  unsigned short *texbufw=(unsigned short*)lrect.pBits;
  tx=begr(toint(x*FXRES), TXRES);
  ty=begr(toint(y*FYRES), TYRES);
    color=texbuf[ty*TXRES+tx];
  r=((color&0xFF0000)>>16)-32;
  if(r<br)r=br;
  g=((color&0xFF00)>>8)-32;
  if(g<bg)g=bg;
  b=(color&0xFF)-32;
  if(b<bb)b=bb;
  color=(0xFF<<24)+(r<<16)+(g<<8)+b;
    texbuf[ty*TXRES+tx]=color;
  if(dxstexture[TEXSPACEOFF+j*TEXX+i]->UnlockRect(0)!=D3D_OK)dxerror();
  if(tx==0||ty==0){
    int il, jo;
    if(tx==0){il=begr(i-1, TEXX);}else{il=i;}
    if(ty==0){jo=begr(j-1, TEXY);}else{jo=j;}
    if(dxstexture[TEXSPACEOFF+jo*TEXX+il]->LockRect(0, &lrect, NULL, 0)!=D3D_OK)dxerror();
    texbuf=(unsigned int*)lrect.pBits;
    texbufw=(unsigned short*)lrect.pBits;
    int otx, oty;
    if(tx==0){otx=TXRES-1;}else{otx=tx;}
    if(ty==0){oty=TYRES-1;}else{oty=ty;}
      texbuf[oty*TXRES+otx]=color;
    if(dxstexture[TEXSPACEOFF+jo*TEXX+il]->UnlockRect(0)!=D3D_OK)dxerror();
  }
  if(tx==TXRES-1||ty==TYRES-1){
    int il, jo;
    if(tx==TXRES-1){il=begr(i+1, TEXX);}else{il=i;}
    if(ty==TYRES-1){jo=begr(j+1, TEXY);}else{jo=j;}
    if(dxstexture[TEXSPACEOFF+jo*TEXX+il]->LockRect(0, &lrect, NULL, 0)!=D3D_OK)dxerror();
    texbuf=(unsigned int*)lrect.pBits;
    texbufw=(unsigned short*)lrect.pBits;
    int otx, oty;
    if(tx==TXRES-1){otx=0;}else{otx=tx;}
    if(ty==TYRES-1){oty=0;}else{oty=ty;}
      texbuf[oty*TXRES+otx]=color;
    if(dxstexture[TEXSPACEOFF+jo*TEXX+il]->UnlockRect(0)!=D3D_OK)dxerror();
  }
}

void pathway(float x1, float y1, float x2, float y2, float size){
  int k;
  status(1050);
  if(absf(x1-x2)>absf(y1-y2)){
    if(x1>x2){
      float x3, y3;
      x3=x1;
      y3=y1;
      x1=x2;
      y1=y2;
      x2=x3;
      y2=y3;
    }
    float step=1.0/(float)FXRES;
    status(1051);
  //  if(absf(x2-x1)!=0)step/=absf(x2-x1);
    for(k=0;k<(int)(88*sqrt(size));k++){
      float xp=(begr(rand(), 2000)/500.0f-2.0f)*size, yp=(begr(rand(), 2000)/500.0f-2.0f)*size;
      float xp2=xp+size*0.3f*(begr(rand(), 2000)/500.0f-2.0f), yp2=yp+size*0.3f*(begr(rand(), 2000)/500.0f-2.0f);
      float xp3=xp+size*0.3f*(begr(rand(), 2000)/500.0f-2.0f), yp3=yp+size*0.3f*(begr(rand(), 2000)/500.0f-2.0f);
  //    status(k);
      for(float i=x1;i<x2;i+=step){
        float j=(float)(i-x1)/(float)(x2-x1)*(float)(y2-y1)+y1;
        addpixel(i+xp+size*xp2*((float)(i-x1)/(float)(x2-x1))+size*xp3*(1-((float)(i-x1)/(float)(x2-x1)))
               , j+yp+size*yp2*((float)(i-x1)/(float)(x2-x1))+size*yp3*(1-((float)(i-x1)/(float)(x2-x1))));
        if(GetAsyncKeyState(VK_ESCAPE)!=0)break;
      }
      if(GetAsyncKeyState(VK_ESCAPE)!=0)break;
    }
  }
  if(absf(x1-x2)<=absf(y1-y2)){
    if(y1>y2){
      float x3, y3;
      x3=x1;
      y3=y1;
      x1=x2;
      y1=y2;
      x2=x3;
      y2=y3;
    }
    float step=1.0/(float)FYRES;
    status(1051);
   //  if(absf(x2-x1)!=0)step/=absf(x2-x1);
    for(k=0;k<(int)(88*sqrt(size));k++){
      float xp=(begr(rand(), 2000)/500.0f-2.0f)*size, yp=(begr(rand(), 2000)/500.0f-2.0f)*size;
      float xp2=xp+size*0.3f*(begr(rand(), 2000)/500.0f-2.0f), yp2=yp+size*0.3f*(begr(rand(), 2000)/500.0f-2.0f);
      float xp3=xp+size*0.3f*(begr(rand(), 2000)/500.0f-2.0f), yp3=yp+size*0.3f*(begr(rand(), 2000)/500.0f-2.0f);
  //    status(k);
      for(float i=y1;i<y2;i+=step){
        float j=(float)(i-y1)/(float)(y2-y1)*(float)(x2-x1)+x1;
        addpixel(j+xp+size*xp2*((float)(i-y1)/(float)(y2-y1))+size*xp3*(1-((float)(i-y1)/(float)(y2-y1)))
               , i+yp+size*yp2*((float)(i-y1)/(float)(y2-y1))+size*yp3*(1-((float)(i-y1)/(float)(y2-y1))));
        if(GetAsyncKeyState(VK_ESCAPE)!=0)break;
      }
      if(GetAsyncKeyState(VK_ESCAPE)!=0)break;
    }
  }
  status(1052);
}

void terrainit(void){
  int i, j, k, l, m;
  float thmap[FIELDX*FIELDY];
  float min, max;
  struct timeb t2;
  ftime(&t2);
  //srand(t2.millitm+1000*t2.time);
  status(1000);
  for(i=0;i<FIELDX;i++){
    for(j=0;j<FIELDY;j++){
      thmap[i*FIELDX+j]=(float)begr(rand(), 10000);
    }
  }
  status(1001);
  int anz=1;
  for(k=0;k<anz;k++){
    for(i=0;i<FIELDX;i++){
      for(j=0;j<FIELDY;j++){
        thmap[i*FIELDX+j]=(thmap[i*FIELDX+j]+thmap[begr(i+1,FIELDX)*FIELDX+j]+thmap[i*FIELDX+begr(j+1,FIELDY)]+thmap[begr(i+1,FIELDX)*FIELDX+begr(j+1,FIELDY)]
                    +thmap[begr(i-1,FIELDX)*FIELDX+j]+thmap[i*FIELDX+begr(j-1,FIELDY)]+thmap[begr(i-1,FIELDX)*FIELDX+begr(j-1,FIELDY)])/7;
      }
    }  
  }
  status(1002);
  for(l=0;l<TERRAPLAINS;l++){
    if(terra.plain[l].used){
      for(k=0;k<8;k++){
        int ib=(int)(terra.plain[l].x-terra.plain[l].dx/2);
        int is=(int)(terra.plain[l].x+terra.plain[l].dx/2);
        int jb=(int)(terra.plain[l].y-terra.plain[l].dy/2);
        int js=(int)(terra.plain[l].y+terra.plain[l].dy/2);
        for(i=ib;i<is;i++){
          for(j=jb;j<js;j++){
            thmap[begr(i, FIELDX)*FIELDX+begr(j, FIELDY)]=(thmap[begr(i, FIELDX)*FIELDX+begr(j, FIELDY)]+thmap[begr(i+1,FIELDX)*FIELDX+begr(j, FIELDY)]
                        +thmap[begr(i, FIELDX)*FIELDX+begr(j+1,FIELDY)]+thmap[begr(i+1,FIELDX)*FIELDX+begr(j+1,FIELDY)]
                        +thmap[begr(i-1,FIELDX)*FIELDX+begr(j, FIELDY)]+thmap[begr(i, FIELDX)*FIELDX+begr(j-1,FIELDY)]+thmap[begr(i-1,FIELDX)*FIELDX+begr(j-1,FIELDY)])/7;
          }
        }  
      }
    }
  }
  for(m=0;m<TERRAWAYS;m++){
    if(terra.way[m].used){
      float x3,y3;
      float x1=terra.way[m].x1, y1=terra.way[m].y1;
      float x2=terra.way[m].x2, y2=terra.way[m].y2;
      int plainsize;
      float size;
      if(terra.way[m].typ==0){
        plainsize=3;
        size=0.6f;
      } else {
        plainsize=2;
        size=0.25f;
      }
      if(absf(x1-x2)>absf(y1-y2)){ // bresenham or so
        if(x1>x2){
          x3=x1;
          y3=y1;
          x1=x2;
          y1=y2;
          x2=x3;
          y2=y3;
        }
        status(1003);
        for(i=(int)x1;i<(int)x2;i++){
          int x=i;
          int y=(int)(y1+((float)(y2-y1))*(((float)(i-x1))/((float)(x2-x1))));
          for(k=0;k<4;k++){
            for(i=x-plainsize;i<x+plainsize;i++){
              for(j=y-plainsize;j<y+plainsize;j++){
                thmap[begr(i, FIELDX)*FIELDX+begr(j, FIELDY)]=(thmap[begr(i, FIELDX)*FIELDX+begr(j, FIELDY)]+thmap[begr(i+1,FIELDX)*FIELDX+begr(j, FIELDY)]+thmap[begr(i, FIELDX)*FIELDX+begr(j+1,FIELDY)]+thmap[begr(i+1,FIELDX)*FIELDX+begr(j+1,FIELDY)]
                            +thmap[begr(i-1,FIELDX)*FIELDX+begr(j, FIELDY)]+thmap[begr(i, FIELDX)*FIELDX+begr(j-1,FIELDY)]+thmap[begr(i-1,FIELDX)*FIELDX+begr(j-1,FIELDY)])/7;
              }
            }  
          }
        }
        status(1004);
      } else {
        if(y1>y2){
          x3=x1;
          y3=y1;
          x1=x2;
          y1=y2;
          x2=x3;
          y2=y3;
        }
        status(1005);
        for(l=(int)y1;l<(int)y2;l++){
          int x=(int)(x1+((float)(x2-x1))*(((float)(l-y1))/((float)(y2-y1))));
          int y=l;
          for(k=0;k<4;k++){
            for(i=x-plainsize;i<x+plainsize;i++){
              for(j=y-plainsize;j<y+plainsize;j++){
                thmap[begr(i, FIELDX)*FIELDX+begr(j, FIELDY)]=(thmap[begr(i, FIELDX)*FIELDX+begr(j, FIELDY)]+thmap[begr(i+1,FIELDX)*FIELDX+begr(j, FIELDY)]+thmap[begr(i, FIELDX)*FIELDX+begr(j+1,FIELDY)]+thmap[begr(i+1,FIELDX)*FIELDX+begr(j+1,FIELDY)]
                            +thmap[begr(i-1,FIELDX)*FIELDX+begr(j, FIELDY)]+thmap[begr(i, FIELDX)*FIELDX+begr(j-1,FIELDY)]+thmap[begr(i-1,FIELDX)*FIELDX+begr(j-1,FIELDY)])/7;
              }
            }  
          }
        }
        status(1006);
      }
      pathway(terra.way[m].x1, terra.way[m].y1, terra.way[m].x2, terra.way[m].y2, size);
    }
  }
  status(1007);
  min=thmap[0*FIELDX+0];
  max=thmap[0*FIELDX+0];
  for(i=0;i<FIELDX;i++){
    for(j=0;j<FIELDY;j++){
      if(thmap[i*FIELDX+j]>max)max=thmap[i*FIELDX+j];
      if(thmap[i*FIELDX+j]<min)min=thmap[i*FIELDX+j];
    }
  }  
  status(1008);
  for(i=0;i<FIELDX;i++){
    for(j=0;j<FIELDY;j++){
      terra.hmap[i][j]=(unsigned char)(((thmap[i*FIELDX+j]-min)/(max-min))*255.0);
    }
  }
}

float height(float x, float y){
  int xi, yi;
  x/=TERRAFAC;
  y/=TERRAFAC;
  xi=x<0?((int)x-1):(int)x;
  yi=y<0?((int)y-1):(int)y;
  return -(terra.hmap[begr(xi, FIELDX)][begr(yi, FIELDY)]*(1-(x-xi))*(1-(y-yi))
          +terra.hmap[begr(xi+1, FIELDX)][begr(yi, FIELDY)]*(x-xi)*(1-(y-yi))
          +terra.hmap[begr(xi, FIELDX)][begr(yi+1, FIELDY)]*(1-(x-xi))*(y-yi)
          +terra.hmap[begr(xi+1, FIELDX)][begr(yi+1, FIELDY)]*(x-xi)*(y-yi)
          )/255.0f*MAXHEIGHT;
}

void terranorm(void){
  D3DVECTOR v[8];
  int tx, ty;
  for(int j=0;j<FIELDY;j++){
    ty=begr(j, FIELDY)*TEXY/FIELDY;
    for(int i=0;i<FIELDX;i++){
      tx=begr(i, FIELDX)*TEXX/FIELDX;
      terra.tex[i][j]=TEXSPACEOFF+ty*TEXX+tx;
      v[0]=makevector((float)(i)*TERRAFAC, (float)(j)*TERRAFAC, -terra.hmap[begr(i,FIELDX)][begr(j,FIELDY)]/255.0f*MAXHEIGHT);
      v[1]=makevector((float)(i)*TERRAFAC, (float)(j+1)*TERRAFAC, -terra.hmap[begr(i,FIELDX)][begr(j+1,FIELDY)]/255.0f*MAXHEIGHT);
      v[2]=makevector((float)(i+1)*TERRAFAC, (float)(j)*TERRAFAC, -terra.hmap[begr(i+1,FIELDX)][begr(j,FIELDY)]/255.0f*MAXHEIGHT);
      v[3]=makevector((float)(i+1)*TERRAFAC, (float)(j+1)*TERRAFAC, -terra.hmap[begr(i+1,FIELDX)][begr(j+1,FIELDY)]/255.0f*MAXHEIGHT);
      v[4]=makevector((float)(i)*TERRAFAC, (float)(j+2)*TERRAFAC, -terra.hmap[begr(i,FIELDX)][begr(j+2,FIELDY)]/255.0f*MAXHEIGHT);
      v[5]=makevector((float)(i+1)*TERRAFAC, (float)(j+2)*TERRAFAC, -terra.hmap[begr(i+1,FIELDX)][begr(j+2,FIELDY)]/255.0f*MAXHEIGHT);
      v[6]=makevector((float)(i+2)*TERRAFAC, (float)(j+1)*TERRAFAC, -terra.hmap[begr(i+2,FIELDX)][begr(j+1,FIELDY)]/255.0f*MAXHEIGHT);
      v[7]=makevector((float)(i+2)*TERRAFAC, (float)(j)*TERRAFAC, -terra.hmap[begr(i+2,FIELDX)][begr(j,FIELDY)]/255.0f*MAXHEIGHT);
/*      terra.vtx[i][j][0]=makelvertex(v[0], DXNORM(v[0], v[1], v[2]), FXRES*1.0f/TXRES*i-tx, FYRES*1.0f/TYRES*j-ty);
      terra.vtx[i][j][1]=makelvertex(v[1], DXNORM(v[1], v[4], v[3]), FXRES*1.0f/TXRES*i-tx, FYRES*1.0f/TYRES*(j+1)-ty);
      terra.vtx[i][j][2]=makelvertex(v[2], DXNORM(v[2], v[3], v[7]), FXRES*1.0f/TXRES*(i+1)-tx, FYRES*1.0f/TYRES*j-ty);
      terra.vtx[i][j][3]=makelvertex(v[3], DXNORM(v[3], v[5], v[6]), FXRES*1.0f/TXRES*(i+1)-tx, FYRES*1.0f/TYRES*(j+1)-ty);
      terra.detail[i][j][0]=makelvertex(v[0], DXNORM(v[0], v[1], v[2]), 0, 0);
      terra.detail[i][j][1]=makelvertex(v[1], DXNORM(v[1], v[4], v[3]), 2, 0);
      terra.detail[i][j][2]=makelvertex(v[2], DXNORM(v[2], v[3], v[7]), 0, 2);
      terra.detail[i][j][3]=makelvertex(v[3], DXNORM(v[3], v[5], v[6]), 2, 2);*/
	  // mission.light[0].r
	  // mission.light[0].g
	  // mission.light[0].b
	  // mission.light[0].x
	  // mission.light[0].y
	  // mission.light[0].z
	  D3DCOLOR c[4];
	  memset(c, 0, 4*sizeof(D3DCOLOR));
	  int r = 0, g = 0, b = 0;
	  r = (int)(255.0f * mission.light[0].r * crosslight(DXNORM(v[0], v[1], v[2]), makevector(mission.light[0].x, mission.light[0].y, mission.light[0].z)));
	  g = (int)(255.0f * mission.light[0].g * crosslight(DXNORM(v[0], v[1], v[2]), makevector(mission.light[0].x, mission.light[0].y, mission.light[0].z)));
	  b = (int)(255.0f * mission.light[0].b * crosslight(DXNORM(v[0], v[1], v[2]), makevector(mission.light[0].x, mission.light[0].y, mission.light[0].z)));
	  r += (int)(255.0f * mission.light[1].r * crosslight(DXNORM(v[0], v[1], v[2]), makevector(mission.light[1].x, mission.light[1].y, mission.light[1].z)))+0x40;
	  g += (int)(255.0f * mission.light[1].g * crosslight(DXNORM(v[0], v[1], v[2]), makevector(mission.light[1].x, mission.light[1].y, mission.light[1].z)))+0x40;
	  b += (int)(255.0f * mission.light[1].b * crosslight(DXNORM(v[0], v[1], v[2]), makevector(mission.light[1].x, mission.light[1].y, mission.light[1].z)))+0x40;
	  if(r > 255) r = 255;
	  if(g > 255) g = 255;
	  if(b > 255) b = 255;
	  c[0] = (255 << 24) + (r << 16) + (g << 8) + b;
	  r = (int)(255.0f * mission.light[0].r * crosslight(DXNORM(v[1], v[4], v[3]), makevector(mission.light[0].x, mission.light[0].y, mission.light[0].z)));
	  g = (int)(255.0f * mission.light[0].g * crosslight(DXNORM(v[1], v[4], v[3]), makevector(mission.light[0].x, mission.light[0].y, mission.light[0].z)));
	  b = (int)(255.0f * mission.light[0].b * crosslight(DXNORM(v[1], v[4], v[3]), makevector(mission.light[0].x, mission.light[0].y, mission.light[0].z)));
	  r += (int)(255.0f * mission.light[1].r * crosslight(DXNORM(v[1], v[4], v[3]), makevector(mission.light[1].x, mission.light[1].y, mission.light[1].z)))+0x40;
	  g += (int)(255.0f * mission.light[1].g * crosslight(DXNORM(v[1], v[4], v[3]), makevector(mission.light[1].x, mission.light[1].y, mission.light[1].z)))+0x40;
	  b += (int)(255.0f * mission.light[1].b * crosslight(DXNORM(v[1], v[4], v[3]), makevector(mission.light[1].x, mission.light[1].y, mission.light[1].z)))+0x40;
	  if(r > 255) r = 255;
	  if(g > 255) g = 255;
	  if(b > 255) b = 255;
	  c[1] = (255 << 24) + (r << 16) + (g << 8) + b;
	  r = (int)(255.0f * mission.light[0].r * crosslight(DXNORM(v[2], v[3], v[7]), makevector(mission.light[0].x, mission.light[0].y, mission.light[0].z)));
	  g = (int)(255.0f * mission.light[0].g * crosslight(DXNORM(v[2], v[3], v[7]), makevector(mission.light[0].x, mission.light[0].y, mission.light[0].z)));
	  b = (int)(255.0f * mission.light[0].b * crosslight(DXNORM(v[2], v[3], v[7]), makevector(mission.light[0].x, mission.light[0].y, mission.light[0].z)));
	  r += (int)(255.0f * mission.light[1].r * crosslight(DXNORM(v[2], v[3], v[7]), makevector(mission.light[1].x, mission.light[1].y, mission.light[1].z)))+0x40;
	  g += (int)(255.0f * mission.light[1].g * crosslight(DXNORM(v[2], v[3], v[7]), makevector(mission.light[1].x, mission.light[1].y, mission.light[1].z)))+0x40;
	  b += (int)(255.0f * mission.light[1].b * crosslight(DXNORM(v[2], v[3], v[7]), makevector(mission.light[1].x, mission.light[1].y, mission.light[1].z)))+0x40;
	  if(r > 255) r = 255;
	  if(g > 255) g = 255;
	  if(b > 255) b = 255;
	  c[2] = (255 << 24) + (r << 16) + (g << 8) + b;
	  r = (int)(255.0f * mission.light[0].r * crosslight(DXNORM(v[3], v[5], v[6]), makevector(mission.light[0].x, mission.light[0].y, mission.light[0].z)));
	  g = (int)(255.0f * mission.light[0].g * crosslight(DXNORM(v[3], v[5], v[6]), makevector(mission.light[0].x, mission.light[0].y, mission.light[0].z)));
	  b = (int)(255.0f * mission.light[0].b * crosslight(DXNORM(v[3], v[5], v[6]), makevector(mission.light[0].x, mission.light[0].y, mission.light[0].z)));
	  r += (int)(255.0f * mission.light[1].r * crosslight(DXNORM(v[3], v[5], v[6]), makevector(mission.light[1].x, mission.light[1].y, mission.light[1].z)))+0x40;
	  g += (int)(255.0f * mission.light[1].g * crosslight(DXNORM(v[3], v[5], v[6]), makevector(mission.light[1].x, mission.light[1].y, mission.light[1].z)))+0x40;
	  b += (int)(255.0f * mission.light[1].b * crosslight(DXNORM(v[3], v[5], v[6]), makevector(mission.light[1].x, mission.light[1].y, mission.light[1].z)))+0x40;
	  if(r > 255) r = 255;
	  if(g > 255) g = 255;
	  if(b > 255) b = 255;
	  c[3] = (255 << 24) + (r << 16) + (g << 8) + b;
/*	  c[0] = (255<<24)+16777216;
	  c[2] = 0;*/
      terra.vec[i][j][0]=v[0];
      terra.vec[i][j][1]=v[1];
      terra.vec[i][j][2]=v[2];
      terra.vec[i][j][3]=v[3];
      terra.vtx[j][i][0]=makelvertex(v[0], c[0], FXRES*1.0f/TXRES*i-tx, FYRES*1.0f/TYRES*j-ty);
      terra.vtx[j][i][1]=makelvertex(v[1], c[1], FXRES*1.0f/TXRES*i-tx, FYRES*1.0f/TYRES*(j+1)-ty);
      terra.vtx[j][i][2]=makelvertex(v[2], c[2], FXRES*1.0f/TXRES*(i+1)-tx, FYRES*1.0f/TYRES*j-ty);
      terra.vtx[j][i][3]=makelvertex(v[3], c[3], FXRES*1.0f/TXRES*(i+1)-tx, FYRES*1.0f/TYRES*(j+1)-ty);
      terra.detail[j][i][0]=makelvertex(v[0], c[0], 0, 0);
      terra.detail[j][i][1]=makelvertex(v[1], c[1], 2, 0);
      terra.detail[j][i][2]=makelvertex(v[2], c[2], 0, 2);
      terra.detail[j][i][3]=makelvertex(v[3], c[3], 2, 2);
      terra.detaill[j][i][0]=makelvertex(v[0], c[0], 0, 0);
      terra.detaill[j][i][1]=makelvertex(v[1], c[1], 2, 0);
      terra.detaill[j][i][2]=makelvertex(v[2], c[2], 0, 2);
      terra.detaill[j][i][3]=makelvertex(v[2], c[2], 0, 2);
      terra.detaill[j][i][4]=makelvertex(v[1], c[1], 2, 0);
      terra.detaill[j][i][5]=makelvertex(v[3], c[3], 2, 2);
		terra.vbdetail = NULL;
/*      terra.vtx[i][j][0]=makevertex(v[0], DXNORM(v[0], v[1], v[2]), FXRES*1.0f/TXRES*i-tx, FYRES*1.0f/TYRES*j-ty);
      terra.vtx[i][j][1]=makevertex(v[1], DXNORM(v[1], v[4], v[3]), FXRES*1.0f/TXRES*i-tx, FYRES*1.0f/TYRES*(j+1)-ty);
      terra.vtx[i][j][2]=makevertex(v[2], DXNORM(v[2], v[3], v[7]), FXRES*1.0f/TXRES*(i+1)-tx, FYRES*1.0f/TYRES*j-ty);
      terra.vtx[i][j][3]=makevertex(v[3], DXNORM(v[3], v[5], v[6]), FXRES*1.0f/TXRES*(i+1)-tx, FYRES*1.0f/TYRES*(j+1)-ty);*/
    }
  }
}

/*
tt:	currently active texture
*/
void renderterrastrip(int i, int j, int di, int dj, int &tt, bool ttexture)
{
	int over = 0;
//	D3DVECTOR mv;
	while(((over <= 1)||(di != 0 && over <= 4)) && i > 0 && i < FIELDX-1 && j > 0 && j < FIELDY-1)
	{
/*	D3DMATRIX temp;
    gs->d3d->d3ddevice->GetTransform(D3DTS_PROJECTION, &temp);
    D3DMATRIX mtx=makematrix(0.25f,0,0,0, 0,0.25f,0,0, 0,0,1,0, 0,0,0,1);
    gs->d3d->d3ddevice->MultiplyTransform(D3DTS_PROJECTION, &mtx);*/
		if(ttexture)
		{
			if(tt!=terra.tex[i][j] && ttexture){
				tt=terra.tex[i][j];
				gs->d3d->d3ddevice->SetTexture(0, dxstexture[tt]);
			}
/*				D3DVECTOR vc;
			vc = terra.vec[i][j][0];
			mapply3d(&vc);
			vc.x = (vc.x+1)*(XRES/2);
			vc.y = (1-vc.y)*(YRES/2);
			terra.vtx[i][j][0].sx = vc.x;
			terra.vtx[i][j][0].sy = vc.y;
			terra.vtx[i][j][0].sz = vc.z;
			vc = terra.vec[i][j][1];
			mapply3d(&vc);
			vc.x = (vc.x+1)*(XRES/2);
			vc.y = (1-vc.y)*(YRES/2);
			terra.vtx[i][j][1].sx = vc.x;
			terra.vtx[i][j][1].sy = vc.y;
			terra.vtx[i][j][1].sz = vc.z;
			vc = terra.vec[i][j][2];
			mapply3d(&vc);
			vc.x = (vc.x+1)*(XRES/2);
			vc.y = (1-vc.y)*(YRES/2);
			terra.vtx[i][j][2].sx = vc.x;
			terra.vtx[i][j][2].sy = vc.y;
			terra.vtx[i][j][2].sz = vc.z;
			vc = terra.vec[i][j][3];
			mapply3d(&vc);
			vc.x = (vc.x+1)*(XRES/2);
			vc.y = (1-vc.y)*(YRES/2);
			terra.vtx[i][j][3].sx = vc.x;
			terra.vtx[i][j][3].sy = vc.y;
			terra.vtx[i][j][3].sz = vc.z;*/
			if(view.changed)
			{
				terra.lvl0[i][j] = makevector(terra.vec[i][j][1].x, terra.vec[i][j][1].y, 0);
				mapply2d(&terra.lvl0[i][j]);
			}
//			gs->d3d->d3ddevice->DrawPrimitive(D3DPT_TRIANGLESTRIP,D3DBFVF_LVERTEX,&terra.vtx[i][j][0],4,0);
			gs->d3d->d3ddevice->DrawPrimitiveUP(D3DPT_TRIANGLESTRIP, 2, &terra.vtx[j][i][0] ,sizeof(D3DBLVERTEX));
//		gs->d3d->d3ddevice->DrawPrimitive(D3DPT_TRIANGLESTRIP,D3DBFVF_LVERTEX,&terra.vtx[i][j][0],4,0);
		}
		else
		{
/*				D3DVECTOR vc = terra.vec[i][j][0];
			mapply3d(&vc);
			vc.x = (vc.x+1)*(XRES/2);
			vc.y = (1-vc.y)*(YRES/2);
			terra.detail[i][j][0].sx = vc.x;
			terra.detail[i][j][0].sy = vc.y;
			terra.detail[i][j][0].sz = vc.z;
			vc = terra.vec[i][j][1];
			mapply3d(&vc);
			vc.x = (vc.x+1)*(XRES/2);
			vc.y = (1-vc.y)*(YRES/2);
			terra.detail[i][j][1].sx = vc.x;
			terra.detail[i][j][1].sy = vc.y;
			terra.detail[i][j][1].sz = vc.z;
			vc = terra.vec[i][j][2];
			mapply3d(&vc);
			vc.x = (vc.x+1)*(XRES/2);
			vc.y = (1-vc.y)*(YRES/2);
			terra.detail[i][j][2].sx = vc.x;
			terra.detail[i][j][2].sy = vc.y;
			terra.detail[i][j][2].sz = vc.z;
			vc = terra.vec[i][j][3];
			mapply3d(&vc);
			vc.x = (vc.x+1)*(XRES/2);
			vc.y = (1-vc.y)*(YRES/2);
			terra.detail[i][j][3].sx = vc.x;
			terra.detail[i][j][3].sy = vc.y;
			terra.detail[i][j][3].sz = vc.z;*/
			gs->d3d->d3ddevice->DrawPrimitiveUP(D3DPT_TRIANGLESTRIP, 2, &terra.detail[j][i][0] ,sizeof(D3DBLVERTEX));
//			gs->d3d->d3ddevice->DrawPrimitive(D3DPT_TRIANGLESTRIP,D3DBFVF_LVERTEX,&terra.detail[i][j][0],4,0);
	//		gs->d3d->d3ddevice->DrawPrimitive(D3DPT_TRIANGLESTRIP,D3DBFVF_LVERTEX,&terra.detail[i][j][0],4,0);
		}
		if(di == 0 && dj != 0)
		{
			renderterrastrip(i + 1, j,  1, 0, tt, ttexture);
			renderterrastrip(i - 1, j, -1, 0, tt, ttexture);
		}
		if(!(terra.lvl0[i][j].x > -1 && terra.lvl0[i][j].x < 1 && terra.lvl0[i][j].y > -1 && terra.lvl0[i][j].y < 1))
			over++;
		if(i < terra.pbnx[j]) terra.pbnx[j] = i;
		if(i > terra.pbxx[j]) terra.pbxx[j] = i;
		if(j < terra.pbny) terra.pbny = j;
		if(j > terra.pbxy) terra.pbxy = j;
		i+=di;
		j+=dj;
	}
	if(i < terra.mini) terra.mini = i;
	if(i > terra.maxi) terra.maxi = i;
	if(j < terra.minj) terra.minj = j;
	if(j > terra.maxj) terra.maxj = j;
}

void renderterra(void){
//  D3DBVERTEX vx[4];
  int i, j, tt=-1;
  int fac;
  int l=(LEFTEND+(int)view.px)/TERRAFAC, r=(RIGHTEND+(int)view.px)/TERRAFAC, o=(TOPEND+(int)view.py)/TERRAFAC, u=(BOTTOMEND+(int)view.py)/TERRAFAC;
  if(view.firstperson)o+=FIRSTTOPPLUS/TERRAFAC;
  gs->d3d->d3ddevice->SetTextureStageState( 0, D3DTSS_ADDRESSU, D3DTADDRESS_CLAMP);
  gs->d3d->d3ddevice->SetTextureStageState( 0, D3DTSS_ADDRESSV, D3DTADDRESS_CLAMP);
  matrix=makematrix(1,0,0,0, 0,1,0,0, 0,0,1,0, 0,0,0,1);
  gs->d3d->d3ddevice->SetTransform(D3DTS_WORLD, &matrix);
  // D3DBFVF_LVERTEX
  if(view.firstperson)
  {
	  for(j=u;j<o;j++){
		fac=(12-(12*(j-u))/(o-u))/TERRAFAC;
		if(view.firstperson)fac=(30-(45*(j-u))/(o-u))/TERRAFAC;
		for(i=l+fac;i<r-fac;i++){
		  if(tt!=terra.tex[i][j]){
			tt=terra.tex[i][j];
			gs->d3d->d3ddevice->SetTexture(0, dxstexture[tt]);
		  }
/*		  D3DTLVERTEX v[4];
		  D3DVECTOR vc = makevector(terra.vtx[i][j][0].x, terra.vtx[i][j][0].y, terra.vtx[i][j][0].z);
		  mapply3d(&vc);
		  v[0] = D3DTLVERTEX(vc, 1, terra.vtx[i][j][0].color, terra.vtx[i][j][0].specular, terra.vtx[i][j][0].tu, terra.vtx[i][j][0].tv);
		  vc = makevector(terra.vtx[i][j][1].x, terra.vtx[i][j][1].y, terra.vtx[i][j][1].z);
		  mapply3d(&vc);
		  v[1] = D3DTLVERTEX(vc, 1, terra.vtx[i][j][1].color, terra.vtx[i][j][1].specular, terra.vtx[i][j][1].tu, terra.vtx[i][j][1].tv);
		  vc = makevector(terra.vtx[i][j][2].x, terra.vtx[i][j][2].y, terra.vtx[i][j][2].z);
		  mapply3d(&vc);
		  v[2] = D3DTLVERTEX(vc, 1, terra.vtx[i][j][2].color, terra.vtx[i][j][2].specular, terra.vtx[i][j][2].tu, terra.vtx[i][j][2].tv);
		  vc = makevector(terra.vtx[i][j][3].x, terra.vtx[i][j][3].y, terra.vtx[i][j][3].z);
		  mapply3d(&vc);
		  v[3] = D3DTLVERTEX(vc, 1, terra.vtx[i][j][3].color, terra.vtx[i][j][3].specular, terra.vtx[i][j][3].tu, terra.vtx[i][j][3].tv);

		  gs->d3d->d3ddevice->DrawPrimitive(D3DPT_TRIANGLESTRIP,D3DFVF_TLVERTEX,&v,4,0);*/
			gs->d3d->d3ddevice->DrawPrimitiveUP(D3DPT_TRIANGLESTRIP, 2, &terra.vtx[j][i][0] ,sizeof(D3DBLVERTEX));
		}
	  }
  }
  else
  {
	  if(view.changed)
	  {
		  i = (l+r)/2;
		  j = (o+u)/2;
		  terra.mini = FIELDX-1;
		  terra.maxi = 0;
		  for(int k = 0; k < FIELDY; k++)
		  {
			  terra.pbnx[k] = FIELDX-1;
			  terra.pbxx[k] = 0;
		  }
		  terra.pbny = terra.minj = FIELDY-1;
		  terra.pbny = terra.maxj = 0;
		  renderterrastrip(i, j, 0, 1, tt, true);
		  renderterrastrip(i, j-1, 0, -1, tt, true);
		  if(terra.mini <= 0){ view.px+=15*speedgs.c*view.zoom;view.changedr = true;}
		  if(terra.maxi >= FIELDX-1){ view.px-=15*speedgs.c*view.zoom;view.changedr = true;}
		  if(terra.minj <= 0){ view.py+=15*speedgs.c*view.zoom;view.changedr = true;}
		  if(terra.maxj >= FIELDY-1){ view.py-=15*speedgs.c*view.zoom;view.changedr = true;}
	  }
	  else
	  {
				/*if(gs->d3d->d3ddevice->CreateVertexBuffer(sizeof(D3DBLVERTEX) * 4, D3DUSAGE_WRITEONLY, D3DBFVF_LVERTEX, D3DPOOL_MANAGED,&terra.vbterra) == D3D_OK)
				{
					unsigned char *p;
						gs->d3d->d3ddevice->SetStreamSource(0, terra.vbterra, sizeof(D3DBLVERTEX));
					if(terra.vbterra->Lock(0, 0, &p, 0) == D3D_OK)
					{*/

		  for(int ty = terra.pbny; ty <= terra.pbxy; ty++)
		  {
						//memcpy(p, terra.vtx[ty][terra.pbnx[ty]], sizeof(D3DBLVERTEX) * (terra.pbxx[ty]-terra.pbnx[ty]+1) * 4);
			  for(int tx = terra.pbnx[ty]; tx <= terra.pbxx[ty]; tx++)
			  {
				if(tt!=terra.tex[tx][ty])
					gs->d3d->d3ddevice->SetTexture(0, dxstexture[tt=terra.tex[tx][ty]]);
//				gs->d3d->d3ddevice->DrawPrimitive(D3DPT_TRIANGLESTRIP,D3DBFVF_LVERTEX,&terra.vtx[tx][ty][0],4,0);
				gs->d3d->d3ddevice->DrawPrimitiveUP(D3DPT_TRIANGLESTRIP, 2, &terra.vtx[ty][tx][0] ,sizeof(D3DBLVERTEX));

					/*	memcpy(p, terra.vtx[ty][tx], sizeof(D3DBLVERTEX) * 4);
		//				gs->d3d->d3ddevice->SetVertexShader( D3DBFVF_LVERTEX );
						gs->d3d->d3ddevice->DrawPrimitive( D3DPT_TRIANGLESTRIP, 0*4*(tx-terra.pbnx[ty]), 2 );*/
				}
			  }
		 /* }
						terra.vbterra->Unlock();
					}
					RELEASE(terra.vbterra);*/
	  }
  }
  gs->d3d->d3ddevice->SetTextureStageState( 0, D3DTSS_ADDRESSU, D3DTADDRESS_WRAP);
  gs->d3d->d3ddevice->SetTextureStageState( 0, D3DTSS_ADDRESSV, D3DTADDRESS_WRAP);
  if(!dxsoftware){
	// multipass detail texture blending
	gs->d3d->d3ddevice->SetRenderState(D3DRS_ALPHABLENDENABLE, TRUE);
//	gs->d3d->d3ddevice->SetRenderState(D3DRS_BLENDOP, TRUE);
  //  gs->d3d->d3ddevice->SetRenderState(D3DRS_SRCBLEND, D3DBLEND_SRCALPHA);
	gs->d3d->d3ddevice->SetRenderState(D3DRS_SRCBLEND, D3DBLEND_SRCALPHA);
	gs->d3d->d3ddevice->SetRenderState(D3DRS_DESTBLEND, D3DBLEND_INVSRCALPHA);
	if(mission.snow){
	  gs->d3d->d3ddevice->SetTexture(0, dxstexture[8]);
	} else {
	  gs->d3d->d3ddevice->SetTexture(0, dxstexture[2]);
	}
	if(view.firstperson)
	{
		for(j=u;j<o;j++){
		  fac=(12-(12*(j-u))/(o-u))/TERRAFAC;
		  if(view.firstperson)fac=(30-(45*(j-u))/(o-u))/TERRAFAC;
		  for(i=l+fac;i<r-fac;i++){
//			gs->d3d->d3ddevice->DrawPrimitive(D3DPT_TRIANGLESTRIP,D3DBFVF_LVERTEX,&terra.detail[i][j][0],4,0);
			gs->d3d->d3ddevice->DrawPrimitiveUP(D3DPT_TRIANGLESTRIP, 2, &terra.detail[j][i][0] ,sizeof(D3DBLVERTEX));
		  }
		}
	}
	else
	{
		int ty;
		for(ty = terra.pbny; ty <= terra.pbxy; ty++)
			//for(int tx = terra.pbnx[ty]; tx <= terra.pbxx[ty]; tx++)
				if(terra.pbxx[ty]-terra.pbnx[ty]>0)gs->d3d->d3ddevice->DrawPrimitiveUP(D3DPT_TRIANGLELIST, 2*(terra.pbxx[ty]-terra.pbnx[ty]), &terra.detaill[ty][terra.pbnx[ty]][0] ,sizeof(D3DBLVERTEX));
	}
    gs->d3d->d3ddevice->SetRenderState(D3DRS_ALPHABLENDENABLE, FALSE);
//    gs->d3d->d3ddevice->SetRenderState(D3DRS_BLENDENABLE, FALSE);
  }
}
