#ifndef WINDOW_H
#define WINDOW_H


#include <windows.h>

#define WNDCLASSSTR "cwindow_42"

class cwindowlist;

class cwindow
{
	friend cwindowlist;

	WNDCLASS wincl;
	HINSTANCE Instance;
public:
	HWND hwnd;
	int WindowStyle;
	int clientdx, clientdy;

	cwindow(HINSTANCE Instance, int WindowStyle, char *caption, int dx, int dy);
	~cwindow();

	showmaximized();
	shownormal();

	// event functions
	// minimize/maximize
	virtual onmessage(int msg, int wparam, int lparam);
	virtual onminimax(int WindowStyle);
	virtual onactivate();
	virtual ontimer();
	virtual ondeactivate();
	virtual onsize(int dx, int dy);
	virtual onrbuttondown(int x, int y);
	virtual onrbuttonup(int x, int y);
	virtual onlbuttondown(int x, int y);
	virtual onlbuttonup(int x, int y);
	virtual onmousemove(int x, int y, int buttons);
};

// indexing classes
class cwindowlistentry
{
public:
	cwindow *wnd;
	cwindowlistentry *next;

	cwindowlistentry(cwindow *wnd, cwindowlistentry *next);
	~cwindowlistentry();
};

class cwindowlist
{
	cwindowlistentry *list;
public:
	cwindowlist();
	Add(cwindow *wnd);
	Remove(cwindow *wnd);
	cwindow *Get(HWND hwnd);
	~cwindowlist();
};

#endif