#include <d3dx8.h>
#include "xFile.h"

XMESH::XMESH()
	{
	dwNumMaterials = 0;
	pMeshMaterial = NULL;
	pMeshTexture = NULL;
	pMesh = NULL;
	}

XMESH::Load_XFile(char* FileName, LPDIRECT3DDEVICE8 lpD3DDevice)
	{
	LPD3DXBUFFER pMtrlBuffer;
	HRESULT hr;
	hr = D3DXLoadMeshFromX(FileName, D3DXMESH_MANAGED, lpD3DDevice, NULL, &pMtrlBuffer, &dwNumMaterials, &pMesh);
	if(FAILED(hr))
		{
		//Fehler ausgeben
		return FALSE;
		}
	D3DXMATERIAL* d3dxMaterial = (D3DXMATERIAL*)pMtrlBuffer->GetBufferPointer();
	pMeshMaterial = new D3DMATERIAL8[dwNumMaterials];
	pMeshTexture = new LPDIRECT3DTEXTURE8[dwNumMaterials];
	for(DWORD i=0; i<dwNumMaterials; i++)
		{
		pMeshMaterial[i] = d3dxMaterial[i].MatD3D;
		pMeshMaterial[i].Ambient = pMeshMaterial[i].Diffuse; //Ambient wird auf Diffuse color gesetzt aus 3dsmax wird nur die Diffuse color exportiert
		if(FAILED(D3DXCreateTextureFromFile(lpD3DDevice, d3dxMaterial[i].pTextureFilename, &pMeshTexture[i])))
			{
			pMeshTexture[i] = NULL;
			//Fehler ausgeben
			return FALSE;
			}
		}
	pMtrlBuffer->Release();
	return TRUE;
	}

BOOL XMESH::Draw_XFile(LPDIRECT3DDEVICE8 lpD3DDevice)
	{
	for(DWORD i=0; i<dwNumMaterials; i++)
		{
		lpD3DDevice->SetMaterial(&pMeshMaterial[i]);
		if(pMeshTexture)
			{
			lpD3DDevice->SetTexture(0, pMeshTexture[i]);
			}
		pMesh->DrawSubset(i);
		}
	return TRUE;
	}

XMESH::~XMESH()
	{
	if(pMeshMaterial)
		delete[] pMeshMaterial;
	if(pMeshTexture)
		{
		for(DWORD i=0; i<dwNumMaterials; i++)
			if(pMeshTexture[i])
				pMeshTexture[i]->Release();
		delete[] pMeshTexture;
		}
	if(pMesh)
		pMesh->Release();
	}